/*
 * Copyright (C) 1998-2002 Wolfgang Moser <womo_(at)_d81_(dot)_de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Commodore CBM 1581 floppy disk copy util for PC's, 1581COPY.C
 */

#include <stdlib.h>
#include <time.h>
#include "1581hlvl.h"
#include "operatns.h"

const	char *strFOpenEror="File \"%s\" open error.\n";

int main(int argc, char *argv[]){
	int i, res, handle48MHz=0;
   uint8 t,s, TransferError, StpRt=0;	// track and side
	xferM trackJob;
   clock_t opStart;
#ifdef TimeEstimation
   clock_t ETCbase;
   uint8 TracksToDo, TracksDone;
#endif
	unsigned int args=1, earg=1, BAMcp=0, SwapCheck=1, DiskCheck=1;
	char *flpp=NULL, *file=NULL, *temp;

	initBufferPointers();

	for(t=1;t<argc;t++){
		if(argv[t]!=NULL){
			if((*argv[t]=='/' || *argv[t]=='-')){
				if(argv[t][2]=='\0'){		// arguments with no parameter
					switch(argv[t][1]){
						case 'v':
						case 'V':
							VerifyWriting=Verify;
							break;
						case 'f':
						case 'F':
							FormattingDsk=CBM1581;
							break;
						case 'm':
						case 'M':
							MultipleDisks=1;
							break;
						case 'b':
						case 'B':
							BAMcp=1;
							break;
						case 's':
						case 'S':
							SingleSectorC=1;
							break;
						case 'd':
						case 'D':
							SwapCheck=0;
							break;
						case 'n':
						case 'N':
							DiskCheck=0;
							break;
						default:
							args=0xffff;
						}
					}
				else if(argv[t][2]==':'){	// arguments with parameter
					switch(argv[t][1]){
						case 'f':
						case 'F':
                  	if(argv[t][4]=='\0' && (argv[t][3]=='w' || argv[t][3]=='W')){
								FormattingDsk=CBM1581;	// Not needed, because there has an image
                     	FrmtNWrt82078=1;			// to be transferred, it's only for sure
                     	break;
                     	}
								// 1 -> CBM1581, 2 -> CMDFD2M
							FormattingDsk=atoi(argv[t]+3);
							if(FormattingDsk<=FDUNKNW || FormattingDsk>=FDUNDEF) args=0xffff;
							break;
						case 'h':
						case 'H':
                  	if(argv[t][4]=='\0') switch(argv[t][3]){
                  		case 'f':
                  		case 'F':
									handle48MHz=1;
									break;
								default:
									args=0xffff;
                  		case 'n':
                  		case 'N':
									handle48MHz=-1;
                  		}
                  	else args=0xffff;
							break;
						case 'r':
						case 'R':
							StpRt=atoi(argv[t]+3);
							break;
						case 't':
						case 'T':
							NumberRetries=atoi(argv[t]+3);
							if(NumberRetries<1)	args=0xffff;
							break;
						case 'i':
						case 'I':
							SectorIntrlve=atoi(argv[t]+3);
							if(SectorIntrlve>9) args=0xffff;
							break;
						default:
							args=0xffff;
						}
					}
				else args=0xffff;
				}
			else{
         	earg++;
				switch(args++){				// file name arguments
					case 1:
						flpp=argv[t];
						break;
					case 2:
						file=argv[t];
					}
				}
			}
		else args=0xffff;
		if(args>3) break;
		}
	if(file!=NULL && file[0]!='\0' && file[1]==':' && file[2]=='\0') WritingToDisk=Write;

	if(WritingToDisk){	// swap pointers
		temp=file;
		file=flpp;
		flpp=temp;
		}

   earg=(earg!=1);

	printf(_1581COPY_version_
	       "This tool comes with ABSOLUTELY NO WARRANTY; read SRC\\COPYING for details.\n\n");
   do{
		if(args==0xffff){
		   args=0xfffe;
		   if(earg) printf("Error: Wrong parameter detected or help needed");
			break;
         }
		   // convert and check flpp
	   if(flpp==NULL || flpp[1]!=':' || flpp[2]!='\0'){
		   args=0xfffe;
         if(earg) printf("Error: Floppy device parameter is wrong");
         break;
         }
		FloppyDriveNo=*flpp-((*flpp>'Z')?'a':'A');
	   if((FloppyDriveNo & ~0x01)!=0x00){		// only drives A and B are valid
		   args=0xfffe;
     	   if(earg) printf("Error: Only floppy device parameter A: and B: are valid");
        	break;
         }

	   if(!FormattingDsk || WritingToDisk){
		   if(args!=3){
		      args=0xfffe;
            if(earg) printf("Error: Source and destination parameters are needed");
	         break;
            }
		   }
	   else if(args!=2){					// no image file needed
	      args=0xfffe;
		   if(earg) printf("Error: Formatting needs the floppy device parameter only");
         break;
		   }
      else{	// args==2 -> Format only, check for invalid BAM-Copy switch
         if(BAMcp){
		      args=0xfffe;
				earg=1;
			   printf("Error: BAM copy is not useful when formatting only");
      	   break;
         	}
      	else if(FrmtNWrt82078){
		      args=0xfffe;
			   if(earg) printf("Error: Format'n'writing needs source and destination parameter");
      	   break;
      		}
      	}

      if(MultipleDisks && WritingToDisk){		// WritingToDisk of multiple disks is not allowed
	      args=0xfffe;
         earg=1;
		   printf("Error: When using multiple disks, writing is not allowed");
         break;
   	   }
      if(VerifyWriting && !WritingToDisk && !FormattingDsk){
	      args=0xfffe;
         earg=1;
		   printf("Error: Verify cannot be used with read operations");
         break;
      	}
      }while(0);
	if(args==0xfffe && earg) printf("!\n\n");

	if(args>3){
		printf("1581COPY [/F[:x] /V /B /M /S /D /N /R:nnn /I:n /T:nnn /H:s] [SRC] DST\n\n"
				 "  SRC    - select floppy drive A: or B: or image file name\n"
				 "  DST    - select image file name or floppy drives A: or B:\n\n"
				 "  /F[:x] - format before writing, no source needed, if formatting only\n"
				 "      x  - select desired format (2 - CMD FD 2000, default: 1 - CBM 1581)\n"
				 "  /F:W   - select intel 82078 FDC format'n'write feature\n"
				 "  /V     - select verify mode\n\n"
				 "  /B     - BAM copy, only transfer allocated tracks\n"
				 "  /M     - use multiple disks, when reading or formatting only\n"
				 "  /S     - preselect \"read/write single sectors\"\n"
				 "  /D     - disable the \"swapped side ID\" CBM format check\n"
				 "  /N     - don't wait for (first) disk, if there's no disk, then abort\n"
				 "  /R:nnn - use a nonstandard step rate time (1=0.25ms ... 255=63.75ms)\n"
				 "  /I:n   - interleave for higher speed on slow machines (0...9, default 1)\n"
				 "  /T:nnn - number of retries (> 0, default 3)\n"
				 "  /H:s   - disable intel 82078 64pin 48MHz operation autodetection\n"
				 "     s   - selection (f - force 48MHz fix, n - no change/detection)\n"
				 );
		return RetHELP;
		}

	CBMrecalibrate(FloppyDriveNo);
	TransferError=0;

	do{
		switch((unsigned int)(i=getFDCVersion())>>12){
			case 0x0:
		   	temp="unknown FDC (timeout)";
		   	break;
			case 0x8:
		   	temp="NEC PD765, intel 8278, NS DP8473, etc. FDC";
		   	break;
			case 0x9:	// extended controller
				temp="intel 82078 64pin (or compatible) FDC";

				if((i&0x1f)!=0x00) switch((i>>5)&0x07){
					case 0x0:	// intel 82078 64pin compatible controller or substepping
						switch(handle48MHz){
							case 0:		// autodetect
								handle48MHz=handle82078_48(FloppyDriveNo);
								break;
							case 1:		// force fix 48MHz operation
								// handle48MHz=switch48MHz(1)?2:0;
								handle48MHz=switch48MHz(1)<<1;
							// case -1:		// don't change
							// default:	// leave 48MHz bit at current state
							}
							// "intel 82078 64pin (or compatible) FDC";
				   	temp[12]='6';
				   	continue;
					case 0x2:	// intel 82078 44pin compatible controller or substepping
							// "intel 82078 64pin (or compatible) FDC";
							//  0123456789012
				   	temp[12]='4';
				   		// jump to the end of do-while, don't exec FnW disable!
				   	continue;
					}
		   	temp="extended FDC (unknown part id)";
		   	break;
			default:
		   	temp="unknown floppy disk controller";
			}
   	FrmtNWrt82078=0;	// don't support this feature
		}while(0);
	
	if(!FormattingDsk || !WritingToDisk) FrmtNWrt82078=0;

	printf("1581-Copy setup:\n - FDC type      : %s, version 0x%04X\n"
			 " - Drive         : %c:\n - Retries       : %d\n"
			 " - Interleave    : %d\n - Step rate time: ",
			 temp, i,'A'+FloppyDriveNo, NumberRetries, SectorIntrlve);
	if(StpRt) printf("%d.%02dms (%d)", StpRt/4, (StpRt%4)*25, StpRt);
	else printf("media default");
	printf("\n - Single sector : %s\n"
			 " - Verify        : %s\n - Formatting    : %s\n",
			 SingleSectorC?"on":"off", VerifyWriting?"on":"off",
			 FormattingDsk?"on":"off");

		// mask out bit 6 of the part id and check for intel
	i&=0xFFBF;
	if( ((unsigned int)i>0x9000) && ((unsigned int)i<=0x901F) ){	// It's an intel FDC
		printf(" - Format'n'Write: %s\n"
		       " - external 48MHz: %s\n"
	          ,
#ifdef ForceFnWVerify
			    FrmtNWrt82078?"on (verifying forced, RTFM)":"off"
#else
			    FrmtNWrt82078?"on":"off"
#endif
		       ,handle48MHz<=0?(handle48MHz?"not changed":"ERROR with fixing 48MHz operation"):(handle48MHz>1?"fixed":"not detected")
				 );
		}

	/*
	 * Parameter parsing and checking and printing of the current
	 * configuration is done, now we can start with the real work
	 */

	printf("\nLow-level-%s CBM disk in drive %c:\n\n", WritingToDisk?"writing":(FormattingDsk?"formatting":"reading"), 'A'+FloppyDriveNo);
	if(DiskCheck && !waitForDiskChng(FloppyDriveNo, 0)) exit1581Copy(RetABRT,0);
   do{	// multiple disks - while(MultipleDisks && waitForDiskChng(FloppyDriveNo, 1))

			/* Let's test sometime, if this is needed yet */
		TransferBuffer=getTrackCache(0);		// at least CBMcheckDisk wouldn't need this to be set
		// check source and destination formats
      do{	// disk change - while(waitForDiskChng(FloppyDriveNo, 1))
			if((res=CBMcheckDisk(FloppyDriveNo,SwapCheck))<FDUNKNW) exit1581Copy(RetCNFG,5);
			if(!DiskCheck){
				if(!FormattingDsk && res<=FDUNKNW){
					printf("No or incompatible disk media found with parameter /N\n");
					exit1581Copy(RetUNKW,-1);
					}
				DiskCheck=1;	// Nur _vor_ der Schleife _nicht_ prfen, danach immer
				}

				// CBM media detected in disk FloppyDriveNo
         if(FormattingDsk || res>FDUNKNW){
            if(WritingToDisk){	// search for compatible source image
					t=0;
               s=1;
               	// test without changed extension and with all
						// the other valid extensions (currently D81 and D2M)
					for(i=FDUNKNW;i<FDUNDEF;i++){
	               if((temp=changeExtension(file,0,i))==NULL)
							exit1581Copy(RetEXNX,4);	// new name cannot be generated

			         FileDescriptor=fopen(temp,"r+b");
                  if(FileDescriptor!=NULL){					// file found
                     t=1;
         	         fseek(FileDescriptor,0L,SEEK_END);
                     switch(ftell(FileDescriptor)){
								case  822400L:			// CBM 1581 with error info
            	         case  819200L:			// CBM 1581
                           s=2;					// CBM compatible file found
                           if(FormattingDsk) res=CBM1581;
               	         if(res==CBM1581) s=0;	// depending on CBMcheckDisk, if not formatting
                           break;
								case 1665360L:			// CMD FD2000 with error info
            	         case 1658880L:			// CMD FD2000
                           s=2;					// CBM compatible file found
                           if(FormattingDsk) res=CMDFD2M;
               	         if(res==CMDFD2M) s=0;	// depending on CBMcheckDisk, if not formatting
            	         }
			            fseek(FileDescriptor,0L,SEEK_SET);	// seek to Track 01;00
                     if(!s) break;	// let the file open, if file type matches disk type
						   fclose(FileDescriptor);
                     FileDescriptor=NULL;
                     }
                  }
               if(!s){
                  file=temp;
						break;				// let the file open, if file type matches disk type
                  }
               if(s==1){
                  if(!t){
                  	printf(strFOpenEror,file);
                  	return RetOPEN;
	                  // exit1581Copy(RetOPEN,-1);
                  	}
						else{
							printf("No CBM compatible disk images found.\n");
	                  exit1581Copy(RetCPTL,-1);
							}
                  }
					printf("No matching disk and image media types found. ");
               }
				else{
					switch(FormattingDsk){
                 	default:		// reading only
                  		// change extension to default
                        // force changing only, if multiple disks
                     temp=file;
                     file=changeExtension(file,MultipleDisks,res);
								// if there have no multiple disk to be copied but
								// if extension has been changed (no one was given)
								// then generate a new filename, if needed
						   if(file==NULL) exit1581Copy(RetEXNX,4);	// new name cannot be generated
			            if(MultipleDisks || temp!=file){				// generate new filename, if needed
                        do{
		                     FileDescriptor=fopen(file,"rb");
                              // if reading disk, file mustn't exist
					            if(FileDescriptor==NULL) break;	// new filename found
					            fclose(FileDescriptor);
									FileDescriptor=NULL;
               	            // generate new filename
					            file=buildInxName(file);
                           if(file==NULL) exit1581Copy(RetINDX,3);	// new name cannot be generated
            	            }while(1);
         	            }
	                  FileDescriptor=fopen(file,"w+b");
	                  if(FileDescriptor==NULL){
		                  printf(strFOpenEror,file);
		                  return RetOPEN;
		                  }
							break;
                 	case 1:
							res=CBM1581;
							break;
                  case 2:
							res=CMDFD2M;
                  }
               break;
               }
            }
			else printf("CBM incompatible disk media type detected. ");
         res=FDUNKNW;
      	}while(waitForDiskChng(FloppyDriveNo, 1));
			// abort after unknown media detected or user doesn't want to proceed
      if(res==FDUNKNW) exit1581Copy(RetABRT,-1);

	/*
	 * Media detection finished, now prepare for copying
	 */

      if(FormattingDsk && !WritingToDisk) printf("Formatting ");
		else printf("Transferring ");
      switch(res){
#if (MESSAGES >= 1)
			default:
				printf("\n\nError after fixing the format routine, wrong drive type selected\n");
				return RetFMFX;
#endif
         case CBM1581:
            printf("CBM 1581");
            break;
         case CMDFD2M:
            printf("CMD FD2000");
         }
      if(FormattingDsk && !WritingToDisk) printf(" disk in drive %c:\n",'A'+FloppyDriveNo);
      else{
			printf(" disk from ");
         if(WritingToDisk) printf("image \"%s\" to drive %c:\n",file,'A'+FloppyDriveNo);
         else        printf("drive %c: to image \"%s\"\n",'A'+FloppyDriveNo,file);
         }

      CBMpresetFDprm(FloppyDriveNo,res,StpRt);

		opStart=clock();
      if(!BAMcp) res=FDUNDEF;
		if((res=getTrackAllocation(res))==-1) exit1581Copy(RetABRT,0);
		if(WritingToDisk) fseek(FileDescriptor, 0x0L, SEEK_SET);

	/*
	 * Preparations finished, now start the track processing
	 */

#ifdef TimeEstimation
			// Tracks have to be determined just from the BAM-Copy table
		for(t=TracksToDo=0;t<(FDprm.Cylinders<<1);t++)
			if(BAMcopymarker[t>>3]&(1<<(t&0x07))) TracksToDo++;
		if(FormattingDsk) TracksToDo=FDprm.Cylinders<<1;
			//	TracksToDo<<=1;

#if (MESSAGES >= 1)
		printf("Number of tracks to copy: %2d\n",TracksToDo);
#endif

	   ETCbase=clock();
	   TracksDone=0;
#endif
		for(t=1;t<=FDprm.Cylinders;t++){
			if(WritingToDisk){
				if(fread(getTrackCache(0),1,FDprm.Sectors*((2*128u) << FDprm.BpS),FileDescriptor)!=
										  FDprm.Sectors*((2*128u) << FDprm.BpS))
            	exit1581Copy(RetREAD,1);
				}
			else{	// clear TransferBuffer, if there's a sector not readable,
					// 0x00 is written into the image file
				TransferBuffer=getTrackCache(0);
				for(args=0;args<FDprm.Heads*FDprm.Sectors*(128u << FDprm.BpS);args++)
					TransferBuffer[args]=0;
				}
//			for(s=0,TransferBuffer=getTrackCache(0);s<FDprm.Heads;s++,TransferBuffer+=FDprm.Sectors*(128u << FDprm.BpS)){
			for(s=0;s<FDprm.Heads;s++){
				TransferBuffer=getTrackCache(s);
				trackJob=0;
				if(FormattingDsk){
					trackJob=Format|VerifyWriting;
					}							// t=0...79 -> 0...159 : (t-1)*2+s= t<<1 -2 +s
				i=(t<<1)+s-2;
				if(!BAMcp || BAMcopymarker[i>>3]&(1<<(i&0x07))){
#if (MESSAGES >= 1)
        	      if(BAMcp) printf("BAM copying track %2d\n",t);
#endif
					if(WritingToDisk || FormattingDsk){
						trackJob|=WritingToDisk|VerifyWriting;
					   }
	            else{
						trackJob=Read;	// overwrites a falsely set "Format"
	            	}
					}
				if(trackJob){
#ifdef TimeEstimation
               if(TracksDone!=0)	// prevent division by zero errors
						printf("%2d %1d    ETC: %3lds  \r",t,s,
							((long)(clock()-ETCbase)*(TracksToDo-TracksDone)*10 + (long)(CLOCKS_PER_SEC*5))/(TracksDone*(long)(CLOCKS_PER_SEC*10))
							);
               TracksDone++;
#endif
					res=transferDiskTrack(trackJob,t,s);
					if(res==WRPRTCT || res==NO_DISK) break;
	            if(res<GENFAIL){
						if(!WritingToDisk && !FormattingDsk){
							if(fwrite(getTrackCache(0),1,FDprm.Sectors*((2*128u) << FDprm.BpS),FileDescriptor)!=
														FDprm.Sectors*((2*128u) << FDprm.BpS))
								exit1581Copy(RetWRTE,2);
					      }
						exit1581Copy(RetABRT,0);
	      	      }
					else if(res==GENFAIL){
						printf("Error in all attempts of handling side %1d, cylinder %2d of drive %d\n",s,t,FloppyDriveNo);
						TransferError=1;
						}
					fflush(stdout);
					}// if(trackJob)
			   }// for() - Trackcounter
			if(!WritingToDisk && !FormattingDsk){
				if(fwrite(getTrackCache(0),1,FDprm.Sectors*((2*128u) << FDprm.BpS),FileDescriptor)!=
											FDprm.Sectors*((2*128u) << FDprm.BpS))
            	exit1581Copy(RetWRTE,2);
			   }
			if(res==WRPRTCT || res==NO_DISK) break;
         }
		if(res==WRPRTCT || res==NO_DISK){
			printf("Error in handling disk in drive %d\n",FloppyDriveNo);
			if(res==WRPRTCT) TransferError=2;
			else 				  TransferError=3;
			}
		else if(FormattingDsk && !WritingToDisk){
			if(writeDefaultDisk()==-1) exit1581Copy(RetABRT,0);
			}

	/*
	 * Track processing finished
	 */

		fclose(FileDescriptor);
#if (MESSAGES >= 1)
      printf("FileDescriptor is:%p\n",FileDescriptor);
#endif
		FileDescriptor=NULL;
		printf("Time needed for transferring the last disk: %ld ms\n\n",
				 (10000L*(long)(clock()-opStart))/(long)(CLOCKS_PER_SEC*10));
   	}while(MultipleDisks && waitForDiskChng(FloppyDriveNo, 1));

	CBMrecalibrate(FloppyDriveNo);
	switchMotorOff();

	switch(TransferError){
		case 1:
			printf("A transfer error occured on at least one track of one disk.\n");
			return RetXFER;
		case 2:
			printf("Write protect error on at least one disk.\n");
			return RetWPRT;
		case 3:
			printf("A general controller communications error occured on at least one disk.\n");
			return RetXFER;
		}
   return RetSUCC;
	}
