/*
 * Copyright (C) 1998-2002 Wolfgang Moser <womo_(at)_d81_(dot)_de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Commodore CBM 1581 floppy disk copy util for PC's, CENTRAL.H
 */

#ifndef __Central_1581COPY__
#define __Central_1581COPY__

// version information

#if 1

#define _1581COPY_version_ \
"1581-Copy/FLT, ver. 0.54, 200207142008.  "\
"Copyright (C) 1998-2002 Wolfgang Moser\n"

#else

#define _1581COPY_version_ \
"1581-Copy/FLT, V0.54.07, 200207141752.  "\
"Copyright (C) 1998-2002 Wolfgang Moser\n"

#endif

/*
 * Most important definitions of 1581-Copy
 */

#define MaxSectors (10)					// This controls the size of the internal buffer
												// that is needed for formatting and single sector track
												// copying, it must be greater than or equal to the
												// number of sectors per side (track), that may be used
												// with a desired disk layout

#define TrBufSize (10*1024)			// This controls the size of the track buffer, it must
												// be big enough to hold all the sector data of one side
												// currently: 10 sectors of 1024 bytes for FD2000 disks
#define BAMcpmark ((81*2+7)/8)		// Number of bytes that have to be reservered for the BAM
												// copy track allocation table, 81 tracks with 2 sides
#define FilepathLength (261)			// general buffer for filename operations

#define DISABLE_INTS						// disabling INTs, when programming the DMA controller

#define TimeSlice							// give back remaining time slices to the OS
#define TimeEstimation
#define FD2000BAMSupport

//	#define MESSAGES (3)						// enable some debugging messages
													// >= 6  - enable all messages
                                    	// >= 5  - enable all high level code messages
                                    	// >= 3  - enable working stage high level info
                                    	// >= 2  - enable sector processing high level info
                                    	// >= 1  - enable all main program messages
                                    	// >= 0  - main program error reportations

//	#define USE_TSC							// use system timestamp counter for debug measurements
//	#define USE_P_RDTSC						// use pentium timestamp counter instead of system timer

//	#define ForceFnWVerify					// support for the intel 82078 FDC is enabled now,
													// but do the verify until the test phase is over

//	#define ScanEqual							// enable real a comparison instead of simple CRC verify
													// scanEqual doesn't work, so it let the processor
													// compare, but this is much too lame
			// needs an extra interleave after the verify operation
         // the comparison speed would have to be increased

//	#define CreateMaverickDisk	(0)		// enabling special (wrong) formatting to create
													// Maverick like disks for test purposes
                                    	// define the number to store in the side ID field
//	#define CreateMaverickDisk	(3)		// to test the swap ID check disabling
//	#define CreateMaverickDisk	(i)		// store the number of the sector into the side ID field
													// this is a format, that 1581-Copy definetly cannot handle
//	#define CreateMaverickDisk	(side)	// the correct CBM1581 format
//	#define CreateMaverickDisk	(!side)	// this one would be a correct DOS like format but without a
													// correct bootblock, cannot be read with DOS tools normally
#endif

