; Common receiver-source for ComLink 0.97/0.98
; By Hrsfalvi Levente (C) 1996-2000.
;
; Levente@Terrasoft.HU
;
; Thanx is flyin' to Marko Mkel for suggesting me to
; make common source with conditional ASM.
; Developed with TASM, by Speech Technology Inc.

;   This program is free software; you can redistribute it and/or modify
;   it under the terms of the GNU General Public License as published by
;   the Free Software Foundation; either version 2 of the License, or
;   (at your option) any later version.

;   This program is distributed in the hope that it will be useful,
;   but WITHOUT ANY WARRANTY; without even the implied warranty of
;   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;   GNU General Public License for more details.

;   You should have received a copy of the GNU General Public License
;   along with this program; if not, write to the Free Software
;   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


; Parameters (conditional labels):
; c64    : compile for C64
; plus4  : compile for Plus/4
; serial : compile receiver for serial connection
; quiet  : make quiet version
; prg    : compile loadable file


#ifndef plus4
#define c64
#endif

#ifndef quiet
#define normal
#endif

#ifndef serial
#define parallel
#endif

; common definitions:

chrout = $ffd2

size   = $2f
start  = $2b
count  = $2d
in     = $fe
ystr   = $ff

#ifdef c64
      *= $ce00
serreg = $dd00
prlreg = $dd01
prmadd = $fc
atnom  = %00001000
clkom  = %00010000
dtaom  = %00100000
clkim  = %01000000
dtaim  = %10000000
defm   = %00000111
#define ram ldx #$34 \ stx $01
#define rom ldx #$37 \ stx $01
#endif

#ifdef plus4
      *= $05f5
primm  = $ff4f
serreg = $01
prlreg = $fd10
atnom  = %00000100
clkom  = %00000010
dtaom  = %00000001
clkim  = %01000000
dtaim  = %10000000
defm   = 0
#define ram
#define rom
#endif

#ifdef prg
      *= *-2
      .word *+2
#endif

; Start of the code

st

#ifdef plus4
      lda #$ff
      sta prlreg
#endif

main
      lda #defm
      sta serreg
#ifdef parallel
      lda #0
      sta ps
#endif
#ifdef normal
      jsr primm
      .byte 13
      .text "WAITING FOR TRANSFER..."
      .byte 13,0
#endif

      sei
      jsr bytein
      sta size
      jsr bytein
      sta size+1
      jsr bytein
      sta run
      jsr bytein
      sta run+1
      jsr bytein
      sta start
      sta count
#ifdef parallel
      and #$fe
#endif
      clc
      adc size
      sta e1
#ifdef parallel
      sta e3
#endif
      php
      jsr bytein
      sta start+1
      sta count+1
      plp
      adc size+1
      sta e2
#ifdef parallel
      sta e4
#endif

#ifdef parallel
      lda count
      tax
      and #$fe
      tay
      txa
      and #$01
      sta count
#else
      ldy count
      lda #0
      sta count
#endif

m2
#ifdef parallel
      ldx #defm | dtaom
      lda #clkim
b11   bit serreg
      bne b11
      lda prlreg
      stx serreg

      ram
      sta (count),y
      rom

      iny
e3 =*+1
      cpy #0
      bne m8
#ifdef normal
      lda #'#'
      jsr chrout
#ifdef c64
      sei
#endif
#endif
      lda count+1
e4 =*+1
      cmp #0
      beq m6
m8
      ldx #defm
      lda #clkim
b21   bit serreg
      beq b21
      lda prlreg
      stx serreg
#else
      jsr bytein
#endif
      ram
      sta (count),y
      rom

      iny
      bne m3
      inc count+1
m3
e1 =*+1
      cpy #0
      bne m2
#ifdef normal
      lda #'#'
      jsr chrout
#ifdef c64
      sei
#endif
#endif
      lda count+1
e2 =*+1
      cmp #0
      bne m2

m6
      lda #defm
      sta serreg
#ifdef parallel
      tya
      clc
      adc count
      sta count
      bcc m9
      inc count +1
#else
      sty count
#endif

m9    cli
#ifdef normal
      jsr primm
      .byte 13
      .text "BLOCK LOADED."
      .byte 13,0
#endif
      lda run+1
      cmp #$ff
      bne m5
      lda run
      cmp #$fe
      bne m4
      rts

m4    cmp #$ff
      bne m5
      jmp main
m5
run =*+1
      jsr $0000
      jmp st

      .module bytein
bytein
#ifdef parallel
ps  =*+1
      lda #0
      bne _s2
      lda #clkim
      ldx #defm | dtaom
_b1   bit serreg
      bne _b1
      lda prlreg
      stx serreg
      inc ps
      rts

_s2   lda #clkim
      ldx #defm
_b2   bit serreg
      beq _b2
      lda prlreg
      stx serreg
      dec ps
      rts
#else
      sty ystr
      ldy #3
b3    ldx #defm | atnom
      lda #clkim
b1    bit serreg
      bne b1
      lda serreg
      stx serreg
      asl A
      rol in
      ldx #defm
      lda #clkim
b2    bit serreg
      beq b2
      lda serreg
      stx serreg
      asl A
      rol in
      dey
      bpl b3
      ldy ystr
      lda in
      eor #$ff
      rts
#endif

#ifdef c64
#ifdef normal
      .module primm
primm tsx
      inx
      lda $0100,x
      clc
      adc #$01
      sta prmadd
      inx
      lda $0100,x
      adc #$00
      sta prmadd+1
      ldy #0
_p_l1 lda (prmadd),y
      beq _pend
      jsr chrout
      iny
      bne _p_l1

_pend tya
      dex
      clc
      adc prmadd
      sta $0100,x
      lda prmadd+1
      adc #0
      inx
      sta $0100,x
      rts
#endif
#endif
.end
