{$E-        Don't emulate floating-point part                         }
{$N-        as we don't need it for this program                      }
{$I-        I/O checking off.                                         }

Program ComLink;

{
    ComLink is a small filetransfer and -linker utility for cross-development
    purposes. (PC/DOS - Commodore)

     (C) 1996-2000 Hrsfalvi Levente

    Levente@Terrasoft.HU

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
                                                                      }

Uses Dos;

Const
           PULLUP        = $E4;  {11100100, default value}
           STROBE        = $FE;  {11111110}
           AUTOFD        = $FD;  {11111101}
           SEL_IN        = $F7;  {11110111}
           BIN           = 0;
           OBJ           = 1;
           REL_OBJ       = 2;
           X1541cable    = 0;
           DISK64Ecable  = 1;
           Parallelcable = 2;
           Link2File     = 3;

           OK            = 0;
           BadLptPort    = 1;
           BadInputType  = 2;
           BadCableType  = 3;
           BadStart      = 4;
           BadRun        = 5;
           NoFileName    = 6;
           UnknownSw     = 7;

           Error         = 1;

           timeout       = 1;
           brk           = 2;

           FirstPass     = True;
           SecondPass    = False;

Var
           filename      :string[80];
           LPT_base      :word;
           in_type       :byte;
           cable         :byte;
           start         :word;
           run           :word;
           init          :boolean;
           ATN0,ATN1     :byte;
           DATA0,DATA1   :byte;
           CLK0,CLK1     :byte;
           prmmatrx      :array[1..6] of string[80];
           relfrom,relto :array[0..255] of word;
           inclname      :array[0..63] of string[12];
           incladd       :array[0..63] of word;
           inclnum       :integer;
           makefile      :text;
           dptr          :pointer;
           i,j,k         :word;
           lstart,lend   :word;
           lptr          :pointer;
           lptr2         :pointer;
           lfile         :file;
           prmrow        :string;
           nextrow       :string;


Function C2hex(n1,n2,n3,n4:char):word;
Begin
  If ((n1 >= 'A') and (n1 <= 'F')) Then n1:=Chr(Ord(n1)-7);
  If ((n2 >= 'A') and (n2 <= 'F')) Then n2:=Chr(Ord(n2)-7);
  If ((n3 >= 'A') and (n3 <= 'F')) Then n3:=Chr(Ord(n3)-7);
  If ((n4 >= 'A') and (n4 <= 'F')) Then n4:=Chr(Ord(n4)-7);

  C2hex := ((Ord(n1) - 48) shl 12) +
           ((Ord(n2) - 48) shl 8)  +
           ((Ord(n3) - 48) shl 4)  +
           (Ord(n4) - 48);
End;

Function Hex2c(num:word):string;
Var  i,tmp   :byte;

Begin
  For i := 1 To 4 Do Begin
                     tmp := (num shr ((i-1)*4)) and 15;
                     If tmp <= 9 Then Hex2c[5-i] := Chr(tmp+48)
                                 Else Hex2c[5-i] := Chr(tmp+55);
                     End;
  Hex2c[0] := Chr(4);
End;

Function Traceparams(count:byte):byte;
Var i,j :byte;
    prm :string[80];
    stp :byte;

Begin
 stp := OK;
 in_type          := BIN;
 start            := $ffff;
 filename         := '';
 init             := false;

 i:=1;
 While ((i <= count) and (stp = OK)) Do
   Begin
   prm := prmmatrx[i];
   For j:=1 To Ord(prm[0])+1 Do If ((prm[j]>='a') and (prm[j]<='z'))
                                Then prm[j] := Chr(Ord(prm[j])-32);

   If prm[1] = '-' Then
     Begin
       Case prm[2] of

         'P': Begin
                LPT_base := C2hex('0',prm[3],prm[4],prm[5]);
                If ((LPT_base <> $0378) and
                    (LPT_base <> $0278) and
                    (LPT_base <> $03bc) and
                    (Ord(prm[0]) <> 5))  Then stp := BadLptPort;
              End;

         'C': Begin
               Case prm[3] of
                 'X': cable := X1541cable;
                 'D': cable := DISK64Ecable;
                 'P': cable := Parallelcable;
                 'F': cable := Link2File;
                Else stp := BadCableType;
               End;
               If Ord(prm[0]) <> 3 Then stp := BadCableType;
              End;

         'I': init := True;

         'T': Case prm[3] of
               'B': If Ord(prm[0]) = 3 Then in_type := BIN;
               'H': If Ord(prm[0]) = 3 Then in_type := OBJ
                    Else
                     If (Length(prm) = 4) and (prm[4] = 'X')
                                                     Then in_type := REL_OBJ
                     Else stp := BadInputType;
               Else stp:=BadInputType;
              End;

         'S': If Ord(prm[0]) = 6
                 Then start := C2hex(prm[3],prm[4],prm[5],prm[6])
                 Else stp := BadStart;

         'R': If Ord(prm[0]) = 6
                 Then run := C2hex(prm[3],prm[4],prm[5],prm[6])
                 Else stp := BadRun;

         Else stp:=UnknownSw;

       End;
     End
   Else
       filename := prm;

 Inc(i);
 End;

 If (filename = '') and (not init) Then stp := NoFileName;
 TraceParams := stp;
End;

Procedure SendError(ErrorNum:byte);
Begin

 Case ErrorNum of

   BadLptPort  : Writeln('Invalid LPT-baseaddress!');

   BadCableType: Writeln('[X]1541, [D]isk64e, [P]arallel and [F]ile are valid!');

   BadInputType: Writeln('Only types of [B]inary and [H]ex are valid!');

   BadStart    : Writeln('Bad start-address!');

   NoFileName  : Writeln('...No filename');

   UnknownSw   : Writeln('Unknown switch or parameter!');

 End;
 If ErrorNum <> NoFileName Then Writeln('Cannot link ',filename);
End;

Function InitCon:boolean;
Var  rfname: string[80];

Begin

  Initcon := False;
  If cable = Link2File Then Begin
     If MaxAvail < 65528 Then Begin
                              Writeln('Not enough memory!');
                              FreeMem(dptr,65528);
                              Exit;
                              End;
     GetMem(lptr,65528);
     Asm
        mov  cx,65528
        les  di,lptr
        xor  ax,ax
        cld
        rep stosw
     End;
     lstart := 65527;
     lend   := 0;
     rfname := filename;
     If Pos('.',rfname) <> 0 Then Delete(rfname,Pos('.',rfname),4);
     rfname := rfname + '.BIN';
     Assign(lfile,rfname);
     Rewrite(lfile,1);
     If IOResult <> 0 Then Begin
                           Writeln('I/O error opening ',rfname);
                           Exit;
                           End;
     End
  Else Begin

  Asm
      mov dx,LPT_base
      add dx,2
      mov al,PULLUP
      out dx,al
  End;

  If cable = DISK64Ecable Then Begin
                            ATN0     := SEL_IN;
                            ATN1     := SEL_IN xor $FF;
                            DATA0    := AUTOFD;
                            DATA1    := AUTOFD xor $FF;
                            CLK0     := STROBE;
                            CLK1     := STROBE xor $FF;
                            End

                       Else Begin
                            ATN0     := STROBE;
                            ATN1     := STROBE xor $FF;
                            DATA0    := SEL_IN;
                            DATA1    := SEL_IN xor $FF;
                            CLK0     := AUTOFD;
                            CLK1     := AUTOFD xor $FF;
                            End;
  End;
  InitCon := True;
End;

Function OutBlock(dptr:pointer; LPT_base:word; cable:byte; size:word):byte;
Var res,s               :byte;
    old_s,old_o         :word;

Begin

  If cable = Link2File Then Begin
    Writeln('Linking block...');
    Asm
      mov  ss:res,OK
      les  di,lptr
      push ds
      lds  si,dptr
      mov  bx,si
      mov  cx,ds:[si]
      add  si,4
      lodsw
      add  di,ax
      add  ax,cx
      jnc  @l1
      mov  ss:res,Error
      pop  ds
      jmp  @le
@l1:  cld
      rep movsb
      mov  si,bx
      mov  bx,ds:[si]
      add  si,4
      lodsw
      pop  ds
      add  bx,ax
      cmp  ds:lstart,ax
      jc   @l2
      mov  ds:lstart,ax
@l2:  cmp  ds:lend,bx
      jnc  @le
      mov  ds:lend,bx
@le:
    End;
    If res = Error Then Writeln('Block exceeds boundaries!');
    OutBlock := res;
    End
  Else Begin
    Write('Transferring block: ');
    Asm
      mov  ax,3508h
      int  21h
      mov  ss:old_o,bx
      mov  bx,es
      mov  ss:old_s,bx
      mov  es,ax
      push ds
      mov  dx,offset @newint
      mov  ax,cs
      mov  ds,ax
      mov  ax,2508h
      int  21h
      pop  ds

      mov  s,0
      mov  dx,ss:LPT_base
      add  dx,2
      mov  al,PULLUP
      out  dx,al

      mov  res,OK
      les  si,dptr
      mov  cx,size

@main:
      mov  bh,es:[si]
      push cx
      call @outbyte
      pop  cx
      jc   @timeout

      cmp  cl,0
      jne  @nopress

      mov  dl,'#'
      mov  ah,2
      int  21h
      mov  ah,1
      int  16h
      jz   @nopress

      mov  ah,0
      int  16h
      mov  res,brk
      jmp  @endtrans

@nopress:
      inc  si
      loop @main

      jmp  @endtrans

@timeout:
      mov  res,timeout
      jmp  @endtrans


@outbyte:
      mov  dx,LPT_base
      cmp  cable,Parallelcable
      jne  @sr

      mov  al,bh
      out  dx,al
      mov  bl,DATA1
      add  dx,2
      cmp  s,0
      jne  @p1
      call @sync1
      jc   @out
      mov  s,1
      ret
@p1:  call @sync2
      jc   @out
      mov  s,0
      ret

@sr:  add  dx,2
      mov  bl,ATN1
      mov  cx,4

@s1:
      mov  al,PULLUP
      or   al,CLK1
      shl  bh,1
      jnc  @0b1
      or   al,DATA1
@0b1: out  dx,al

      call @sync11
      jc   @out

      mov  al,PULLUP
      shl  bh,1
      jnc  @0b2
      or   al,DATA1
@0b2: out  dx,al
      call @sync21
      jc   @out
      loop @s1

@out: ret


@sync1:
      in   al,dx
      and  al,PULLUP
      or   al,CLK1
      out  dx,al

@sync11:
      mov  al,00111000b
      out  43h,al
      xor  al,al     {set 1 s delay, using as 'watchdog'}
      out  40h,al
      out  40h,al
      mov  cs:byte ptr @cnt,18

@c1:  in   al,dx
      and  al,bl     {...and wait while the actual synchron-bit goes up}
      jnz  @ok
      cmp  cs:byte ptr @cnt,0
      jne  @c1

      mov  al,PULLUP
      out  dx,al
      stc
      ret

@sync2:
      in   al,dx
      and  al,PULLUP
      out  dx,al

@sync21:
      mov  al,00111000b
      out  43h,al
      xor  al,al
      out  40h,al
      out  40h,al
      mov  cs:byte ptr @cnt,18

@c4:  in   al,dx
      and  al,bl
      jz   @ok
      cmp  cs:byte ptr @cnt,0
      jne  @c4

      mov  al,PULLUP
      out  dx,al
      stc
      ret

@ok:  clc
      ret

@newint:
      push ax
      cmp  cs:byte ptr @cnt,0
      je   @i1
      dec  cs:byte ptr @cnt
      mov  al,00111000b
      out  43h,al
      mov  al,0ffh
      out  40h,al
      out  40h,al
@i1:  mov  al,20h
      out  20h,al
      pop  ax
      iret

@cnt: db  0


@endtrans:
      push ds
      mov  dx,ss:old_s
      mov  ds,dx
      mov  dx,ss:old_o
      mov  ax,2508h
      int  21h
      pop  ds

      mov  al,00110100b
      out  43h,al
      xor  al,al
      out  40h,al
      out  40h,al

      mov  dx,LPT_base
      add  dx,2
      mov  al,PULLUP
      out  dx,al

  End;
  OutBlock := res;
  Writeln;
  Asm
      mov  cx,$ffff
      mov  dx,378h
@r:   in   al,dx
      loop @r
  End;

  If res = timeout Then Writeln('No response from other computer.');
  If res = brk Then     Writeln('Transfer cancelled...');
  End;
End;

Function LoadBBlock(dptr:pointer; var f:file; filename:string; start,run:word):word;
Var  cp:pointer;

Begin
 LoadBBlock := 0;

 If start = $ffff Then Begin
                       If FileSize(f) > 65524 Then Begin
                          Writeln('File is too long!');
                          Exit;
                          End;

                       memw[Seg(dptr^):Ofs(dptr^)  ] := FileSize(f)-2;
                       memw[Seg(dptr^):Ofs(dptr^)+2] := run;
                       cp := Ptr(Seg(dptr^),Ofs(dptr^)+4);

                       Writeln('Loading ',filename,'...');
                       BlockRead(f,cp^,FileSize(f));
                       If IOResult <> 0 Then Begin
                                             Writeln('I/O error...');
                                             Exit;
                                             End;
                       LoadBBlock := FileSize(f)+4;
                       End

                  Else Begin
                       If FileSize(f) > 65522 Then Begin
                          Writeln(filename,' is too long!');
                          Exit;
                          End;

                       memw[Seg(dptr^):Ofs(dptr^)  ] := FileSize(f);
                       memw[Seg(dptr^):Ofs(dptr^)+2] := run;
                       memw[Seg(dptr^):Ofs(dptr^)+4] := start;
                       cp := Ptr(Seg(dptr^),Ofs(dptr^)+6);
                       Write('Loading ',filename,' from $',Hex2C(start));
                       BlockRead(f,cp^,FileSize(f));
                       If IOResult <> 0 Then Begin
                                             Writeln('I/O error...');
                                             Exit;
                                             End;
                       Writeln(' to $',Hex2C(start+FileSize(f)-1));
                       LoadBBlock := FileSize(f)+6;
                       End;
End;

Function LoadHBlock(dptr:pointer; var f:text; run:word):word;
Var arow          :string;
    size,start    :word;
    count,i       :byte;
    cp            :pointer;

Begin

  LoadHBlock := 0;
  size       := 0;
  If nextrow = '' Then Readln(f,arow)
                  Else arow := nextrow;

  count := C2hex('0','0',arow[2],arow[3]);
  If count = 0 Then Exit;
  start := C2hex(arow[4],arow[5],arow[6],arow[7]);
  memw[Seg(dptr^):Ofs(dptr^)+4] := start;
  cp := Ptr(Seg(dptr^),Ofs(dptr^)+6);

  Write('Loading block from $',Hex2C(start));

  Repeat
    For i := 0 To count-1 Do
       memw[Seg(cp^):Ofs(cp^)+i] :=
                            C2hex('0','0',arow[i shl 1 +10],arow[i shl 1+11]);

    cp := Ptr(Seg(cp^),Ofs(cp^)+count);
    Inc(size,count);
    Readln(f,arow);
    If IOResult <>0 Then Begin
                         Writeln;
                         Writeln('I/O error...');
                         Exit;
                         End;

    count := C2hex('0','0',arow[2],arow[3]);

  Until ((count=0) or (C2hex(arow[4],arow[5],arow[6],arow[7])<>start+size)
                   or (size > 65400));

  If size > 65400 Then Begin
                       Writeln('Block is too long!');
                       size := 0;
                       Exit;
                       End;

  nextrow := arow;
  memw[Seg(dptr^):Ofs(dptr^)] := size;
  Write(' to $',Hex2C(start+size));

  If count = 0 Then memw[Seg(dptr^):Ofs(dptr^)+2] := run
               Else memw[Seg(dptr^):Ofs(dptr^)+2] := $ffff;

  LoadHblock := size+6;
End;

Function LoadR_ITables(var f:text):byte;
Var res,i,j :byte;
    row     :string;

Begin

  res := 0;
  Repeat
   ReadLn(f,row);
   For i:=1 To Length(row)+1 Do row[i]:=UpCase(row[i]);

   i := Pos('R_',row);
   j := Pos('$',row);
   If (i = 1) and (j > 1) Then
    Begin
     relfrom[res] := C2hex(row[3],row[4],row[5],row[6]);
     relto[res]   := C2hex(row[j+1],row[j+2],row[j+3],row[j+4]);
     Inc(res);
    End
   Else
    Begin
    i := Pos('I_',row);
    If (i = 1) and (j > 1) and (inclnum < 64) Then
     Begin
     inclname[inclnum] := Copy(row,3,Pos(' ',row)-3)+'.BIN';
     incladd[inclnum]  := C2hex(row[j+1],row[j+2],row[j+3],row[j+4]);
     Inc(inclnum);
     End;
    End;

  Until (EOF(f));

  LoadR_ITables := res;
End;

Function TransferFile(dptr:pointer; filename:string; LPT_base:word;
                                    cable,in_type:byte; start,run:word):byte;
Var size    :word;
    st      :word;
    relnum  :byte;
    bfile   :file;
    hfile   :text;
    rfile   :text;
    Outres  :byte;
    rfname  :string[20];
    i       :word;

Begin
  TransferFile := Error;
  If in_type = BIN Then
     Begin
       Assign(bfile,filename);
       Reset(bfile,1);
       If IOResult <> 0 Then Begin
                             Writeln('Cannot open ',filename,'!');
                             Exit;
                             End;

       size := LoadBBlock(dptr,bfile,filename,start,run);
       Close(bfile);

       If size = 0 Then Exit;
        {And then transfer the block}
       TransferFile := OutBlock(dptr,LPT_base,cable,size);
     End
  Else
     Begin
       If in_type = REL_OBJ Then
         Begin
         rfname := filename;
         If Pos('.',rfname) <> 0 Then Delete(rfname,Pos('.',rfname),4);
         rfname := rfname + '.EXP';
         Writeln('Checking export-file: ',rfname);
         Assign(rfile,rfname);
         Reset(rfile);
         If IOresult <> 0 Then Begin
                               Writeln('Cannot open ',rfname,'!');
                               Exit;
                               End;
         relnum := LoadR_ITables(rfile);
         Close(rfile);
         OutRes:=OK;
         For i:=1 to inclnum Do Begin
             OutRes:=TransferFile(dptr,inclname[i-1],LPT_base,cable,BIN,
                                       incladd[i-1],$ffff);
             If OutRes <> OK Then Exit;
             End;

         End;
       nextrow := '';
       Assign(hfile,filename);
       Reset(hfile);
       Writeln('Loading ',filename,'...');
       If IOResult <> 0 Then Begin
                             Writeln('Cannot open ',filename,'!');
                             Exit;
                             End;
       Repeat
         size := LoadHblock(dptr,hfile,run);
         Outres:=OK;
         If size <> 0 Then
           Begin
           If in_type = REL_OBJ Then
            Begin
            st := memw[Seg(dptr^):Ofs(dptr^)+4];
            i := 0;
            While (i < relnum) and (st <> relfrom[i]) do Inc(i);
            If i < relnum Then
             Begin
             Writeln(' relocating to $',Hex2c(relto[i]));
             memw[Seg(dptr^):Ofs(dptr^)+4] := relto[i];
             End
            Else Writeln;
            End
           Else Writeln;
           OutRes := OutBlock(dptr,LPT_base,cable,size);
           End
         Else Writeln;

       Until ((size = 0) or (Outres <> OK));
       Close(hfile);
       If (Outres = OK) Then Transferfile := OK;

     End;
End;

Begin
 {cn:=0; {***}
 Asm
   in  al,061h
   and al,0fch
   or  al,01h
   out 061h,al
 End;

 LPT_base := $0378;
 cable    := Link2File;
 inclnum  := 0;

  Writeln;
  Writeln('ComLink V0.98 (C)1996-2000 Hrsfalvi Levente');
  Writeln;
  If ParamCount = 0 Then
      Begin
       Writeln('Usage: COMLINK [filename] [-pxxx] [-cx] [-tx] [-sxxxx] [-rxxxx]');
       Writeln('Or   : COMLINK -i [-pxxx]');
       Writeln('-p: LPT base-address');
       Writeln('-c: [X]1541, [D]isk64E or [P]arallel cable or link to [F]ile');
       Writeln('-t: [B]inary or [H]exadecimal (object) input-file with e[X]port-file');
       Writeln('-s: Start address of the raw binary data');
       Writeln('-r: Run code from hex xxxx');
       Writeln('-i: Just initialize the LPT to release I/O lines.');
       Writeln('You can use some special values as');
       Writeln('-SFFFF : ComLink will use the first bytes of the file as start-address.');
       Writeln('-RFFFE : Back to Basic after transferring.');
       Writeln('-RFFFF : Skip start-procedure after transferring.');
       Writeln('Defaults : -P378 -CF -TB -SFFFF -RFFFF');
       Writeln;
       Writeln('This program is free software; you can redistribute it and/or modify');
       Writeln('it under the terms of the GNU General Public License as published by');
       Writeln('the Free Software Foundation.');
       Writeln;
       Halt;
       End;

  If ParamCount > 6 Then
      Begin
       Writeln('Too many parameters!');
       Halt;
      End;

  For i:=1 To ParamCount Do prmmatrx[i]:=ParamStr(i);

  j := TraceParams(ParamCount);

  If j <> OK Then Begin
                  SendError(j);
                  Halt;
                  End;

  If init Then Begin
               Asm
                  mov dx,LPT_base
                  add dx,2
                  mov al,PULLUP
                  out dx,al
               End;
               Writeln('Portbits initialized.');
               Halt(0);
               End;

  If MaxAvail < 65528 Then Begin
                           Writeln('Not enough memory!');
                           Halt(1);
                           End;
  GetMem(dptr,65528);

  If not(InitCon) Then Halt(1);

  j := TransferFile(dptr,filename,LPT_base,cable,in_type,start,run);

  If cable = Link2File Then Begin

     lptr2 := Ptr(Seg(lptr^),Ofs(lptr^)+lstart);
     If j <> Error Then BlockWrite(lfile,lptr2^,lend-lstart);
     If IOResult<>0 Then Begin
                         Writeln('I/O error!');
                         j := Error;
                         End;
     Close(lfile);
     FreeMem(lptr,65528);
     End;

  FreeMem(dptr,65528);
  ExitCode := j;

End.
