/*
 * Copyright (C) 1998-2002 Wolfgang Moser <womo_(at)_d81_(dot)_de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2, or (at your option)
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program (see the file COPYING); if not, write to the
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/*
 * Commodore CBM 1581 floppy disk copy util for PC's, OPERATNS.H
 */

#ifndef __Transfer_Operations__
#define __Transfer_Operations__

#include <stdlib.h>
#include <stdio.h>
#include "1581hlvl.h"
#include "frmheadr.h"

extern unsigned char	*TransferBuffer;
extern unsigned char *TBufButterflyPtr;

extern FILE				*FileDescriptor;

extern unsigned int	 FloppyDriveNo;
extern unsigned int	 MultipleDisks;
extern unsigned int	 SingleSectorC;
	// the following three would have been better combined into one "xferM" variable
extern FDprmSet		 FormattingDsk;
extern xferM			 WritingToDisk;
extern xferM			 VerifyWriting;

extern unsigned int	 FrmtNWrt82078;
extern unsigned int	 NumberRetries;
extern unsigned int	 SectorIntrlve;
extern unsigned char *BAMcopymarker;	// BAM copy track TransferBuffer (168 tracks)

typedef enum{
	RetSUCC=  0,	// operation completed successfully, or the multiple disks copy
						// loop has been exited by user request
   RetHELP=  1,	// command line parameter error or help called
	RetABRT=  2,	// operation has been aborted by user request

	RetCNFG= 10,	// configuration error, wrong drive type (no 3,5" drive)
	RetWPRT= 11,	// disk write protect error (format protect error, too)
	RetXFER= 12,	// unrecoverable disk transfer error on at least 1 track
						// (read, write, format, or verify errors)
	RetUNKW= 13,	// no or CBM incompatible disk found with switch /N

	RetOPEN= 20,	// image file open error
	RetREAD= 21,	// image file read error
	RetWRTE= 22,	// image file write error
	RetCPTL= 23,	// no CBM compatible image file(s) found

	RetINDX= 30,	// automatic filename (index) generation error
	RetEXNX= 31,	// automatic extension generation error

	RetTBOR= 40,	// track buffer out of range error

	RetFMFX=100		//	1xx -  special debug return codes
	}ExitCode;

void				initBufferPointers(void);
unsigned char *getTrackCache		(int No);

void				exit1581Copy		(ExitCode retcode, unsigned int stdmsg);
ENo				transferDiskTrack	(xferM xfer ,uint8 cyl, uint8 side);
int				getTrackAllocation(FDprmSet type);
int				writeDefaultDisk	(void);

char				*buildInxName		(char *inStr);
char				*changeExtension	(char *inStr, int force, FDprmSet Set);

#endif
