; **** cload v1.6b - Unexpanded VIC 20 download utility ****

; Copyright (c) >NIL: June 1997

; This is (at least) the sixth version of a CBM Amiga to CBM VIC-20 File
; Sender program, and the third one using interrupts.
; I used interrupts for I wanted to keep the ability to abort a faulty 
; transmission via keyboard (which, of course, should never be the case 
; with this prg!). But as the Flag and Keyboard IT are handled by the
; same CIA (CIA-A btw.), I found the straightforward solution I used in
; the first versions, consisting in disabling CIA-A IT's, and checking 
; the 'Flag' flag in a loop, also disabled keyboard scanning. So, there 
; was no other possibility of recovery when jammed that a warm reset! 

; Notes: Won't download files to big for an unexpanded VIC
;        Press the <Ctrl> key to abort downloading


;Code_Seg
;=======================================


; > Main Code
Start:	movem.l	d0/a0,-(a7)		; Store Params Size & Address
	jsr	Init			; Perform some init
	movem.l	(a7)+,d0/a0		; Restore Params

	subq.l	#1,d0			; Corrects File Length
	beq	Usage			; No Params
	cmp.l	#64,d0
	bge	LongFN			; FileName's too long
	lea	FileName(pc),a1
	move.l	d0,FileNameSize		; Spare FileName's Size
	subq.l	#1,d0

Copy:	move.b	(a0)+,(a1)+		; Copy FileName
	dbra	d0,Copy	
	clr.b	(a1)+			; Clear last byte
	clr.b	(a1)

	jsr	Load			; Load file in memory
	jsr	H_Init			; Init Header

	clr.b	Status			; Clear Status Byte	
	jsr	Set_IT			; Set CIA-A Flag IT

; > From now on, our code will be executed on Flag IT

; > Initiate Transfer

	move.b	Header(pc),$bfe101	; Send 1st Byte
	bset.b	#0,Status		; Set 'Waiting' Flag

Wait:	btst.b	#1,Status		; Done ?
	bne 	Exit			; Yes => Exit
	btst.b	#6,Status		; Overflow?
	cmp.b	#$39,$bfec01		; <Ctrl> Key to stop
	bne	Wait

Exit:	jsr	Set			; Restore LED
	jsr	Rem_IT			; Remove Flag IT
TeXit:	; Don't close dos.library
	move.l	DosBase(pc),a6		; dos.library BA
	clr.l	d1			; Status Nominal on Exit
	jsr	-$90(a6)		; Exit()
	rts				; Bye.



; > Flag IT Code
IT_Code:jsr	Toggle			; Toggle LED on each ACK received
	btst.b	#0,6(a1)		; Test 'Waiting' Flag
	beq	Ex_IT			; Discard last interrupt
 	subq	#1,(a1)			; One more acknowledged byte
	beq	Done			; Everything's been acknowledged
	bmi	OverFl			; N Flag Set => Overflow Error
	move.l	2(a1),a0		; Retreive Byte_Ptr
	move.b	(a0)+,$bfe101		; Send Byte to Parallel Port
	move.l	a0,2(a1)		; Spare Pointer

Ex_IT:	clr.l	d0			; Status Nominal on IT Exit
	rts

Unex:	bset.b	#7,6(a1)		; Set 'Unexpected IT Error' Flag
	move.l	#SUnexpMsg,d2
	move.l	#EUnexpMsg-SUnexpMsg,d3
	jsr	Write			; Unexpected Interrupt Error
	jmp	Ex_IT(pc)

OverFl:	bset.b	#6,6(a1)		; Set 'Overflow Error' Flag
	move.l	#SOverflMsg,d2
	move.l	#EOverflMsg-SOverflMsg,d3
	jsr	Write			; Overflow Error
	jmp	Ex_IT(pc)

Done:	bclr.b	#0,6(a1)		; Clr 'Waiting' Flag
	bset.b	#1,6(a1)		; Set 'Done' Flag
	jmp	Ex_IT(pc)


; > Toggle LED	
Toggle:	btst.b	#1,$bfe001
	beq	Unset
Set:	bclr.b	#1,$bfe001
	rts
Unset:	bset.b	#1,$bfe001
	rts


; > Load
Load:	move.l	DosBase(pc),a5		; dos.library BA
	lea	FileName(pc),a0
	move.l	a0,d1			; File Name in D1
	move.l	#-2,d2			; Read Mode in D2
	jsr	-$54(a5)		; Lock()
	tst.l	d0			; Returned Lock in D0
	beq	Lock			; Gottaproblem?
	move.l	d0,FileLock		; Spare FileLock 

	move.l	DosBase(pc),a5		; dos.library BA
	move.l	d0,d1			; FileLock in D1
	move.l	#Buffer,d2		; InfoBlock BA in D2
	and.l	#$fffffffc,d2		; LongWord Aligned Required
	move.l	d2,a4			; Spare InfoBlock BA
	jsr	-$66(a5)		; Examine()
	tst.l	d0			
	beq	Exam			; Gottaproblem?
	move.l	124(a4),d0		; File Length in D0
	cmp.l	#$1000,d0		; Is Length > 4 Kb?
	bpl	TooLong			; Won't fit in!
	cmp.l	#$3,d0			; Is Length < 3 bytes
	bmi	TooShrt			; File Too Short to be a VicProg
	move.l	d0,FileSize		; Spare Size (Word)

	move.l	DosBase(pc),a5
	move.l	#FileName,d1		; File Name in D1		
	move.l	#1005,d2		; mode_old
	jsr	-$1e(a5)		; Open()
	tst.l	d0
	beq	NotOpen			; Gottaproblem?
	move.l	d0,FileHandle		; Spare FileHandle

	move.l	DosBase(pc),a5
	move.l	d0,d1			; FileHandle in D1
	move.l	#FileBuffer,d2		; File Buffer Address in D2
	move.l	FileSize(pc),d3		; Size in D3 (Long)
	move.l	d3,-(a7)		; Spare Expected Size
	jsr	-$2a(a5)		; Read()
	move.l	(a7)+,d1		; Expected Size in D1
	cmp.l	d0,d1			; Nb of Bytes Read in D0
	bne	NotRead			; Problem

	jsr	Close			; Close File
	jsr	UnLock			; UnLock File
	rts	

Close:	move.l	DosBase(pc),a5
	move.l	FileHandle(pc),d1
	jsr	-$24(a5)		; Close() File
	rts

UnLock:	move.l	DosBase(pc),a5
	move.l	FileLock(pc),d1
	jsr	-$5a(a5)		; Unlock() File
	rts


; > Header Init (NB: 1st Byte is not sent by IT)
H_Init:	lea	Header+1(pc),a0		; Set Start Byte for IT
	move.l	a0,Byte_Ptr

	move.w	FileBuffer(pc),d0	; Start Address (LSB, MSB) in D0
	rol.w	#8,d0			; Get it in MSB, LSB order

	move.l	FileSize(pc),d1		; Size (Word in MSB, LSB order)
	subq.w	#2,d1			; Substract Start Address

	move.b	d1,BufferSize_LSB	; End Y value in VIC's code

	move.w	d0,SO_Basic		; Start of Basic     = Prg Start
	move.w	d0,BufferPtr		; Start Pointer 
	subq.w	#1,BufferPtr		; (corrected for Y begins at 1)

	add.w	d1,d0			; Compute Prg End Address in D0
	move.w	d0,SO_Variables		; Start of Variables = End of Prg
	move.w	d0,SO_Arrays		; Start of Arrays    = id.
	move.w	d0,EO_Arrays		; End of Arrays      = id.

	move.w	d1,Bytes_To_Send	; Compute Nb of Bytes to send
	move.b	Bytes_To_Send(pc),d0	; MSB of Buffer Size
	add.w	#Buffer-Header, Bytes_To_Send ; Correction
	
	add.b	BufferPtr(pc),d0	; Compute EndPointer MSB
	move.b	d0,EndPointer_MSB	; [Start Address-1] MSB + Size MSB
					 
	rts


; > Init
Init:	move.l	$4,a6			; exec.library BA
	lea	DosName(pc),a1		; dos.library BA
	jsr	-$198(a6)		; OldOpenLibrary()
	move.l	d0,DosBase		; Spare Address
	beq	ErrBye			; Exit with Error Flag

	move.b 	#$ff,$bfe301		; Set all lines to Output
	rts

; > Interrupt Handling Init
Set_IT:	move.l	$4,a6			; exec.library BA
	move.l	#22,d0			; 22 bytes for Interrupt Struct	
	move.l	#$10002,d1		; Chip, cleared RAM
	jsr	-$c6(a6)		; AllocMem()
	move.l	d0,NodeAdress		; Spare Return Adress
	beq	Alloc			; Failure?
	move.l	d0,a2			; Interrupt Node BA
	; > Set Interrupt Struct
	move.b	#$2,$8(a2)		; Interrupt Type
	lea	NodeName(pc),a1
	move.l	a1,10(a2)		; Pointer to Node Name
	lea	IT_Data(pc),a1		
	move.l	a1,14(a2)		; Pointer to Flag IT Data
	lea	IT_Code(pc),a1
	move.l	a1,18(a2)		; Pointer to Flag IT Code 	
	; > Add Flag Interrupt to CIA-A
	move.l	$4,a6			; exec.library BA
	lea	CIA_Name(pc),a1		; Resource Name
	clr.l	d0			; Version
	jsr	-$1f2(a6)		; OpenResource()
	move.l	d0,CIA_Adress		; Spare CIA-A Resource BA
	beq	CIARes			; Problem?
	move.l	d0,a6
	; Get rid of previous Flag IT if exists
	move.l	#$4,d0			; IntVector #4 (Flag IT)
	jsr	-$c(a6)			; ClrInterrupt()
	; Set New Flag IT
	move.l	NodeAdress(pc),a1	; Interrupt Struct Adress
	move.l	#$4,d0			; Flag IT
	jsr	-$6(a6)			; SetInterrupt 
	rts


; > Clean up Flag IT
Rem_IT:	move.l	CIA_Adress,a6		; CIA-A Resource BA
	move.l	#$4,d0			; Flag IT
	jsr	-$c(a6)			; ClrInterrupt()

	move.l	$4,a6			; exec.library BA
	jsr	FreeMem			; Free Allocated Memory
	rts

FreeMem:move.l	NodeAdress, a1		; Adress of Allocated RAM
	move.l	#22,d0			; 22 bytes to free
	jsr	-$d2(a6)		; FreeMem()
	rts


; > Write Message to Standard Output
;   D2 = Message Pointer
;   D3 = Message Length

Write:	move.l	DosBase(pc),a6		; Retreive dos.library BA
	jsr	-$3c(a6)		; Output()
	move.l	d0,d1			; Output-Handle in D1
	jsr	-$30(a6)		; Write()
	rts


; > Various Error Handling Routines

; > Write Error Message and Exit
Error:	jsr Write
ErrBye:	move.l	#1,d1			; Error Status for DOS
	jsr	-$90(a6)		; Exit()
	rts				; Leave Program.


TestM:	move.l	#FileName,d2
	move.l	FileNameSize,d3
	bra	Error


Usage:	move.l	#SUsgMsg,d2
	move.l	#EUsgMsg-SUsgMsg,d3
	bra	Error

LongFN:	move.l	#SLongFNMsg,d2
	move.l	#ELongFNMsg-SLongFNMsg,d3
	bra	Error

Lock:	move.l	#SLockMsg,d2
	move.l	#ELockMsg-SLockMsg,d3
	bra	Error

Exam:	jsr	UnLock
	move.l	#SExamMsg,d2
	move.l	#EExamMsg-SExamMsg,d3
	bra	Error

TooLong:jsr	UnLock
	move.l	#STooLongMsg,d2
	move.l	#ETooLongMsg-STooLongMsg,d3
	bra	Error

TooShrt:jsr	UnLock
	move.l	#STooShortMsg,d2
	move.l	#ETooShortMsg-STooLongMsg,d3
	bra	Error	

NotOpen:jsr	UnLock
	move.l	#SNotOpenMsg,d2
	move.l	#ENotOpenMsg-SNotOpenMsg,d3
	bra	Error

NotRead:jsr	Close
	jsr	UnLock
	move.l	#SNotReadMsg,d2
	move.l	#ENotReadMsg-SNotReadMsg,d3
	bra	Error

Alloc:	move.l	#SAllocErrMsg,d2
	move.l	#EAllocErrMsg-SAllocErrMsg,d3
	bra	Error

CIARes:	jsr	FreeMem
	move.l	#SCIAResMsg,d2
	move.l	#ECIAResMsg-SCIAResMsg,d3
	bra	Error




;Data_Seg
;=======================================

DosBase:	dc.l	0
FileSize:	dc.l	0
FileLock:	dc.l	0
FileHandle:	dc.l	0
NodeAdress:	dc.l	0
CIA_Adress:	dc.l	0
FileNameSize:	dc.l	0
FileName:	blk.b	64,'.'

DosName:	dc.b	"dos.library",0,0
		even
NodeName:	dc.b	"CIA-A Flag Interrupt",0
		even
CIA_Name:	dc.b	"ciaa.resource",0
		even


SUsgMsg:	dc.b	"Usage : cload filename",$a
EUsgMsg:	even
SLongFNMsg:	dc.b	"File name is too long!",$a
ELongFNMsg:	even
SUnexpMsg:	dc.b	"Unexpected Flag Interrupt!",$a
EUnexpMsg:	even
SOverflMsg:	dc.b	"Overflow (Too many bytes requested)!",$a
EOverflMsg:	even
SLockMsg:	dc.b	"Can't find file!",$a
ELockMsg:	even
SExamMsg	dc.b	"Can't Examine file.",$a
EExamMsg:	even
STooLongMsg:	dc.b	"This file is too long to fit in an unexpanded "
		dc.b	"VIC memory!",$a
ETooLongMsg:	even
STooShortMsg:	dc.b	"This file is really too short to be a VIC "
		dc.b	"Program.",$a
ETooShortMsg:	even
SNotOpenMsg:	dc.b	"Can't open file.",$a
ENotOpenMsg:	even
SNotReadMsg:	dc.b	"Read Error.",$a
ENotReadMsg:	even
SAllocErrMsg:	dc.b	"Can't allocate memory.",$a
EAllocErrMsg:	even
SCIAResMsg:	dc.b	"Can't open CIA-A resource.",$a
ECIAResMsg:	even


IT_Data:
Bytes_To_Send:	dc.w	0	; Number of Bytes remaining to send
Byte_Ptr  	dc.l	0	; Next Byte to send
Status		dc.b	0	; Status : Bit 7 - Unexpected IT Error
		even		;	   Bit 6 - Overflow Error
				;	   Bit 1 - Done (Trans. Completed)
				;	   Bit 0 - Waiting (for ACK)
Header:
EO_Arrays:	dc.w	0	; End of Arrays		(VIC DEF $32, $31)
SO_Arrays:	dc.w	0	; Start of Arrays	(VIC DEF $30, $2F)
SO_Variables:	dc.w	0	; Start of Variables	(VIC DEF $2E, $2D)
SO_Basic:	dc.w	0	; Start of Basic	(VIC DEF $2C, $2B)
BufferPtr:	dc.w	0	; Start Pointer		(USR DEF $2A, $29)
FileBuffer:			; File Buffer (overlaid)
BufferSize_LSB:	dc.b	0	; Buffer Size LSB	(USR DEF $28)
EndPointer_MSB:	dc.b	0	; End Pointer MSB	(USR DEF $27)

Buffer:		blk.b	$1000,0	; 4 KB are enough for an unexpanded VIC 
				; NB : First 2 Bytes of FileBuffer, which 
				; lay over BufferSize_LSB & EndAddress_MSB
				; contain Buffer Start Adress in LSB, MSB

