/*******************************************************/
/* input64.h                                           */
/* (c) by Andreas Matthies                             */
/* please report bugs and comments to                  */
/* email: andreas.matthies@arcormail.de                */
/*******************************************************/

#ifndef _input64
#define _input64

#include "loader.h"

struct input64info_t {
	enum {short_pulse, middle_pulse, long_pulse, unknown_pulse} pulse;
	long middle_count;
	char bits_in_byte;
	long header_count;
	char know_byte_border;
	unsigned char actual_byte;
	unsigned char actual_bit;
	long next_databyte;
	long parity_count;
};

static void reset_input64();
static void init_input64();
static void analyse_input64(prg_t * ,tap_t);

extern struct loader_t input64;

#endif
