/*******************************************************/
/* loader.h                                            */
/* (c) by Andreas Matthies                             */
/* please report bugs and comments to                  */
/* email: andreas.matthies@arcormail.de                */
/*******************************************************/

#ifndef _loader
#define _loader

#define MAXLOADERS 100
#define MAXPRGSIZE 131072
#define MAXCBMHEADERSIZE 255

typedef enum {headersearch,headerload,datasearch,dataload,loadok,loaderror} prgstate_t;
typedef enum {prg_rom,prg_turbotape,prg_input64,prg_novaload} prgtype_t; 

typedef struct {
	short loadok, loaderror;
	prgtype_t type;
	prgstate_t state;
	char changestate;
	char name[256];
	unsigned short begin;
	unsigned short end;
	unsigned char data[MAXPRGSIZE];
	unsigned long databegin;
} prg_t;

typedef unsigned long tap_t;


struct loader_t {
	void (*reset_loader)();
	void (*init_loader)();
	void (*analyse_loader)(prg_t *, tap_t);
};

struct loaderlist_t {
	struct loader_t *item[MAXLOADERS];
};

extern struct loader_t *loaderlist[];
extern short lastloader;


#endif
