
#include <sys/types.h>
#include <sys/stat.h>
#include <dirent.h>
#include <stdlib.h>
 
#include	"iecf.h"
#include	"iec_dir.h"
#include	"iec_dsk.h"

static int dirfl,dretp,dretl /*,ddrv */;
static unsigned char retline[MAXLINE];

static void dconvert(void); 
static void showfree(void); 
static int longlen(unsigned long, char*);

void dirini(void)
{
	dirfl=-1;
}

static DIR *fe;
static struct dirent *de;
static char *dirname = NULL;

int iecopendir(int sec,char *name)
{
	int er=0 /* ,fe=0 */;
/*	char *x; */
#ifdef TESTDIR
	printf("opendir:%s\n",name);
#endif
	while(name[0]==' ') name++;
	while(name[0]==':') name++;

	if(dirfl>=0)
	{
		critical(C_TOOMANYF);
		er=E_BRK;
	} else
	{
/*
		ddrv=Dgetdrv();
		if(x=strchr(name,':'))
			ddrv=(name[0]&0x0f)-1;
		else
			x=name;
*/
/*
		if(strcmp(x,"*"))
			strcpy(x,"*.*");
*/
#ifdef TESTDIR
		printf("ddrv=%d\n",ddrv);
#endif
/*
		Fsetdta(&dta);
		fe=Fsfirst(name,FA_READONLY|FA_HIDDEN|FA_SYSTEM|FA_VOLUME|
				FA_SUBDIR|FA_ARCHIVE);
*/
		printf("dirname=%s, name=%s\n",dirname,name);
		if(dirname) {
		  free(dirname);
		  dirname=NULL;
		}
		fe = opendir(name);

		if(fe)
		{
			dirname=malloc(strlen(name)+1);
			if(dirname) strcpy(dirname,name);
			dirfl=sec;
			dretp=0;
			dretl=2;
			strcpy((char*)retline,"\001\004");
			printf("fe=%p, dirname=%s\n", fe, dirname);
		} else {
			if(critical(C_OPENERR))
				er=E_BRK;	
		}
	}
	return(er);
}

int getdirc(int sec)
{
	int c=EOF /* ,fe=0 */;

	if(sec==dirfl)
	{
		if(dretp<dretl)
		{
			c=retline[dretp++];
		} else
		{
			if(dretl!=21)
			{
				if(1 || dretl!=2) {
/*
					fe=Fsnext();
*/
/*printf("Attempt readdir fe=%p\n", fe);*/
					de = readdir(fe);
				}

				if(de)
				{
/*printf("readdir returns %p, errno=%d, fe=%p, dretl=%d\n",de,errno,fe,dretl);*/
					dconvert();
					c=retline[dretp++];
				} else {
/*printf("readdir returns NULL, errno=%d, fe=%p, dretl=%d\n",errno,fe,dretl);*/
					showfree();
					c=retline[dretp++];
				}
			}
		}			
	} else
		critical(C_NOTOPEN);

	return(c);
}

void iecclosedir(int sec)
{
	if(dirfl==sec) {
		dirfl=-1;
		closedir(fe);
	} else
		critical(C_NOTOPEN);
}

static void dconvert(void)
{
	int i,len;

	sprintf((char*)retline,"\001\004");

	strcpy((char*)retline+4,"    ");
	i=1;
	len=4+max(4,i)-i;
	strcpy((char*)retline+len,"\"");
	strcat((char*)retline+len,de->d_name);
	strcat((char*)retline+len,"\"");
	strcat((char*)retline+len,"                    ");
	asc2cbm((char*)retline+4);
	len+=19;
	strcpy((char*)retline+len,"PRG  ");
	len+=6;
/*	
	if(dta.d_attrib&FA_VOLUME)
	{
		retline[2]=retline[3]='\0';
		retline[4]='\022';
		retline[5]='\"';
		strcpy((char*)retline+6,dta.d_fname);
		strcat((char*)retline+6,"                               ");
		retline[22]='\"';
		retline[29]='\0';
		asc2cbm((char*)retline+4);
		len=30;
	} else
	{
		len=longlen(dta.d_length,(char*)retline+2);
		sprintf((char*)retline+4,"%d",len);
		i=(int)strlen((char*)retline+4);
		strcpy((char*)retline+4,"    ");
		len=4+max(4,i)-i;
		strcpy((char*)retline+len,"\"");
		strcat((char*)retline+len,dta.d_fname);
		strcat((char*)retline+len,"\"");
		strcat((char*)retline+len,"                    ");
		asc2cbm((char*)retline+4);
		len+=19;
		if(dta.d_attrib&FA_SUBDIR)
		strcpy((char*)retline+len,"DIR  ");
		else
			strcpy((char*)retline+len,"PRG  ");
		if(dta.d_attrib&FA_READONLY)
			retline[len+3]='*';
		len+=6;
	}
*/
	dretl=len;
	dretp=0;
}

static void showfree(void)
{
/*	DISKINFO	di; */

/*	printf("ddrv=%d,",ddrv+1);*/
/*	Dfree(&di,ddrv+1); */
/*	printf("free=%ld, clsiz=%ld, secsiz=%ld\n",di.b_free,di.b_clsiz,di.b_secsiz);*/
	retline[0]='\001';
	retline[1]='\004';
	longlen(0 /* di.b_free*di.b_clsiz*di.b_secsiz*/,(char*)retline+2);
	strcpy((char*)retline+4," BLOCK(S) FREE");
	retline[19]='\0';
	retline[20]='\0';
	dretl=21;
	dretp=0;
}

static int longlen(unsigned long length,char *s)
{
	int l;
	l=(int)((length&0xff800000l)?(32767):((length>>8)+((length&0xffl)?1:0)));
	s[0]=l&0xff;
	s[1]=(l>>8)&0xff;
	return(l);
}


