
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
 
#include	"iecf.h"
#include	"iec_loop.h"
#include	"iec_dir.h"
#include	"iec_dsk.h"

#define	TEST1

char names[ANZ_N][MAXLINE];

File	f[16];

extern char names[ANZ_N][MAXLINE];

void dskini(void)
{
	int i;
	for(i=0;i<16;i++)
		f[i].state=S_FRE;
}

char 	retbuf[MAXLINE];
int		retp;

int critical(int er)
{
#if 0	/* Atari */
	char *errs[C_MAX]={ "OK", "DRUCKER NICHT BEREIT", "DATEI BEREITS OFFEN",
		"PUFFER-UEBERLAUF", "SCHREIBFEHLER", "KEIN SCHREIBZUGRIFF",
		"DATEI NICHT OFFEN", "SYNTAXFEHLER", "FEHLER BEIM OEFFNEN",
		"DATEI EXISTIERT BEREITS", "DEVICE SPRICHT NICHT AN",
		"KEIN LESEZUGRIFF", "ZU VIELE DATEIEN", "NICHT IMPLEMENTIERT",
		"FEHLER","IEC-BUS ATARI ST V1.0"	};
#endif
#if 1	/* Linux */
	char *errs[C_MAX]={ "OK", "PRINTER NOT READY", "FILE OPEN",
		"BUFFER OVERFLOW", "WRITE ERROR", "NO WRITE ACCESS",
		"FILE NOT OPEN", "SYNTAX ERROR", "ERROR WHEN OPENING",
		"FILE EXISTS", "DEVICE NOT READY",
		"NO READ ACCESS", "TOO MANY FILES", "NOT IMPLEMENTED",
		"ERROR","IEC-BUS LINUX V1.0"	};
#endif
	sprintf(retbuf,"%02d, %s, 00, 00\015",((er)?20:0)-er,errs[-er]);
#if 1 /*def TEST1*/
	printf("critical(%d)=%s\n",-er,retbuf);
#endif

	retp=0;

	f[0x0f].fl=0;
	f[0x0f].state=S_FRE;
	fillbuf(0x0f);

	return(1);
}

void shiftbuf(int sec)
{
	int i;

	if(f[sec].fl)
	{
		f[sec].fl--;
		for(i=0;i<f[sec].fl;i++)
			f[sec].bf[i]=f[sec].bf[i+1];
	}

}

void fillbuf(int sec)
{
	int i,c;

	for(i=f[sec].fl;i<MAXBUF;i++)
	{
		if(f[sec].state&S_EOI)
			break;

		if(sec==0x0f)
		{
			if(!retbuf[retp])
			{
				f[sec].bf[i]=EOF;
				f[sec].state|=S_EOI;
			} else
			{
				f[sec].bf[i]=retbuf[retp++];
			}
		} else
		if((f[sec].state&3)==S_RD)
		{
			if(f[sec].state&S_DIR)
				c=getdirc(sec);
			else
				c=fgetc(f[sec].fp);

			f[sec].bf[i]=c;
			if(c==EOF)
			{
				f[sec].state|=S_EOI;
			}	
		} else
		{
			critical(C_NOTRD);
			break;
		}
	}
	f[sec].fl=i;
}

#define		L_CMD	1
#define		L_OPEN	2
#define		L_FILE	3

int listenflag;
char cmdbuf[MAXLINE];

int dsklistenloop(int secadr)
{
	int er=0,e,sec,c;

/*	printf("dsklistenloop:\n");*/

	sec=secadr&0x0f;

	if(sec==0x0f)
	{
		listenflag=L_CMD;
		f[15].adr=cmdbuf;
		f[15].len=0;
	} else
	if((secadr&0xf0)==0xf0)
	{
		listenflag=L_OPEN;
		if(f[sec].state!=S_FRE)
		{
			if(critical(C_OPEN))
				er=E_BRK;
		}
		else
		{
			f[sec].adr=cmdbuf;
			f[sec].len=0;
		}
	} else
	if(f[sec].state==S_WR)
	{
		listenflag=L_FILE;
	} else
	if(f[sec].state==S_FRE)
	{
		if(critical(C_NOTOPEN))
			er=E_BRK;
	} else
	if(critical(C_NOTWR))
		er=E_BRK;

	if(!er)
	{
		while(((er=liecin(&c))&E_ATN)!=E_ATN)
		{
			e=0;

			switch(listenflag){
			case L_CMD:
			case L_OPEN:
				if(f[sec].len<MAXLINE-1)
				{
					f[sec].adr[f[sec].len++]=c;
				} else
				{
					e=C_BUFOVF;
				}
				break;
			case L_FILE:
				e=fputc(c,f[sec].fp);
				if(e==EOF)
					e=C_WRERROR;
				else
					e=0;
				break;
			default:
				break;
			}

			if(e)
			{
				if(critical(e))
				{
					er|=E_EOI;
					break;
				}
			}
			if(er&E_EOI)
				break;
		}

		switch(listenflag){
		case L_CMD:
			f[15].adr[f[sec].len]='\0';
			cbm2asc(f[15].adr);
			exe_cmd(f[15].adr);
			er=E_EOI;
			break;
		case L_OPEN:
			f[sec].adr[f[sec].len]='\0';
			cbm2asc(f[sec].adr);
			openfile(sec);
			er=E_EOI;
			break;
		case L_FILE:
		default:
			break;
		}
	}
	return(er&(E_EOI|E_BRK));
}

void openfile(int sec)
{
	int 	rwflag,er,i;
	char 	name[2*MAXLINE];
	FILE	*fp;

	er=0;

	critical(C_OK);

	rwflag=(sec!=1)?S_RD:S_WR;

#ifdef TEST1
	printf("openfile:sec=%d,n='%s'\n",sec,f[sec].adr);
#endif

	if(f[sec].adr[0]=='$')
	{
		if(rwflag==S_WR)
		{
			if(critical(C_NOTWR))
				er=E_BRK;
		} else
		{
			rwflag|=S_DIR;

			er=getfname(f[sec].adr+1,name,&i,1);
#ifdef TEST1
			printf("name=%s\n",name);
#endif
			i=(int)strlen(name);
			if(i)
			{
				if((name[i-1]=='\\')||(name[i-1]==':'))
					strcat(name,"*.*");
			}
		}
	} else
		er=getfname(f[sec].adr,name,&rwflag,0);

	if(!er)
	{
/*		printf("name=%s, rw=%d\n",name,rwflag);*/

		if(rwflag==S_WR)
		{
			fp=fopen(name,"rb");
			if(fp)
			{
				if(critical(C_EXIST))
					er=E_BRK;
				fclose(fp);
			} else
			{
				fp=fopen(name,"wb");
				if(!fp)
				{
					if(critical(C_OPENERR))
						er=E_BRK;
				} else
				{
					f[sec].fp=fp;
					f[sec].state=rwflag;
				}
			}
		}else
		if(rwflag&S_DIR)
		{
			if(strlen(name)) {
				er=iecopendir(sec,name);
			} else {
				er=iecopendir(sec,".");
			}
			if(!er)
			{
				f[sec].state=rwflag;
				f[sec].fl=0;
				fillbuf(sec);
			}
		}else
		{
			fp=fopen(name,"rb");
			if(!fp)
			{
				if(critical(C_OPENERR))
					er=E_BRK;
			} else
			{
/*				printf("Datei ffnen:\n");*/
				f[sec].fp=fp;
				f[sec].state=rwflag;
				f[sec].fl=0;
				fillbuf(sec);
				if(f[sec].fl<2)
				{
/*					printf("Datei leer!\n");*/
					iclose(sec);
				}
			}
		}
	}
}

int getfname(char *nx,char *p2,int *rwflag,int fl)
{
	int d,drive,er=0;
	char *p,*px,*n,ny[2*MAXLINE];

	strcpy(ny,nx);
	n=ny;
#ifdef TEST3
	printf("getfname:n=%s,p2=%08lx,fl=%d->",n,p2,fl);
#endif
	while(n[0]==' ') n++;

	drive=-1;
	if((p=strchr(n,':')))
	{
		if(isdigit(*n))
			drive=assigned((*n)&0x0f,n);
		else
		if(isalpha(*n))
			drive=assigned(((*n)&0x0f)-1,n);

		n=strchr(n,':');
		while(n[0]==':')
			n++;
	} else
	if(fl)
	{	
		d=n[0];
		n[0]='\0';
		if(isdigit(d))
			drive=assigned(d&0x0f,n);
		else
		if(isalpha(d))
			drive=assigned((d&0x0f)-1,n);
		if((px=strchr(n,':')))
		{
			n=px;
			while(n[0]==':')
				n++;
		}
	}
/*
	if(px=strchr(n,':'))
	{
		n=px+1;
		while(n[0]==':')
			n++;
	} else
	{
		n+=strlen(n);
	}
*/
/*
	if(drive>=0)
	{
		p2[0]=drive+'A';
		p2[1]=':';
		p2[2]='\\';
		p2[3]='\0';
	} else
*/
		strcpy(p2,names[N_PATH]);

	if(n[0]=='\\')
	{
		if((p=strchr(p2,':')))
			strcpy(p+1,n);
		else
			strcpy(p2,n);
	} else
	{
		strcat(p2,n);
	}

	p=strchr(p2,':');
	if(p==NULL)
		p=p2;
	do{
		if((n=strchr(p,',')))
		{
			switch(n[1]){
			case 'p' :
			case 's' :
			case 'u' :
				break;
			case 'r' :
				*rwflag=S_RD;
				break;
			case 'w' :
				*rwflag=S_WR;
				break;
			default:
				if(critical(C_SYNTAX))
					er=E_BRK;
				break;
			}
			*n='\0';
			p=n+1;
		}
	}while((!er)&&n);	
#ifdef TEST3
	printf("er=%d,p2=%08lx,%s\n",er,p2,p2);
#endif
	return(er);
}	

void cbm2asc(char *name)
{
	while(*name)
	{
		if((name[0]>='A')&&(name[0]<='Z'))
			name[0]+=0x20;
		else
		if(name[0]=='/')
			name[0]='\\';
		else
			name[0]&=0x7f;
	
		name++;
	}
}

void asc2cbm(char *name)
{
	while(*name)
	{
		if((name[0]>='A')&&(name[0]<='Z'))
			name[0]|=0x80;
		else
		if((name[0]>='a')&&(name[0]<='z'))
			name[0]-=0x20;
		else
		if(name[0]=='\\')
			name[0]='/';
		name++;
	}
}

void iclose(sec)
{
	critical(C_OK);

/*	printf("close:%d\n",sec);*/

	if(((f[sec].state&3)==S_RD)||((f[sec].state&3)==S_WR))
	{
		if(f[sec].state&S_DIR)
			iecclosedir(sec);
		else
			fclose(f[sec].fp);

		f[sec].state=S_FRE;
	}
	else
	if(sec!=0x0f)
		critical(C_NOTOPEN);
}


#define	ANZ_CMDS	13 	/* 14 */

char *cmds[ANZ_CMDS]={ "rename","scratch","copy","new","validate",
				"initialize","rmdir","mkdir","chdir",
				"rd","md","cd","assign" /*,"form"*/ };
void (*cmdf[ANZ_CMDS])(char *)={ crename,cscratch,cnotimp,cnotimp,cnotimp,
				cok,crmdir,cmkdir,cchdir,
				crmdir,cmkdir,cchdir,cassign /*,cform*/ };
/*
void cform(char *n)
{
	use_form();
}
*/

void exe_cmd(char *n)
{
	int i,j;

	while(*n==' ')n++;

#ifdef TEST1
	printf("execmd:cmd=%s\n",n);
#endif

	if(n[0])
	{
		critical(C_OK);

		for(i=0;i<ANZ_CMDS;i++)
		{
			j=0;
			while((cmds[i][j])&&(cmds[i][j]==n[j]))j++;
	
			if(j&&(!isalpha(n[j])))
				break;
		}

		if(i==ANZ_CMDS)
			critical(C_SYNTAX);
		else
		{
			while(n[j]==' ') j++;
			(cmdf[i])(n+j);
		}
	}
}

char cn[2*MAXLINE];
int d;

void crename(char *n)
{
	static char n1[2*MAXLINE],n2[MAXLINE],*p,*p1,*p2;

#ifdef TEST1	
	printf("Rename:%s\n",n);
#endif

	if((p1=strchr(n,'='))==NULL)
		critical(C_SYNTAX);
	else
	{
		(p1++)[0]='\0';

		if(strchr(p1,':'))
			critical(C_SYNTAX);
		else
		{
			p2=n1;
			if((p=strchr(n,':'))!=NULL)
			{	
				p++;
				strcpy(n1,n);
				p2=strchr(n1,':')+1;
			} else
				p=n;

			strcpy(p2,p1);
#ifdef TEST3
			printf("n1=%s\n",n1);
#endif
			if(!getfname(n1,n2,&d,0))
			{
				strcpy(n1,n2);

				while(p[0]=='\\')
					p++;

				strcpy(strrchr(n2,'\\')+1,p);
/*
				if(Frename(0,n1,n2))
					critical(C_ERROR);
*/
#ifdef TEST1
				printf("rename\nfrom:%s\nto:%s\n",n1,n2);
				getchar();
#endif
			}
		}
	}
}

void cnotimp(char *n)
{
	critical(C_NOTIMP);
}

void cok(char *n) {}

void cscratch(char *n)
{
	if(!getfname(n,cn,&d,1))
		if(unlink(cn) /* Fdelete(cn) */)
			critical(C_ERROR);
}

void crmdir(char *n)
{
	if(!getfname(n,cn,&d,1))
		if(rmdir(cn) /* Ddelete(cn) */)
			critical(C_ERROR);
}

void cmkdir(char *n)
{
	if(!getfname(n,cn,&d,1))
		if(mkdir(cn,0755) /* Dcreate(cn) */)
			critical(C_ERROR);
}

void cchdir(char *n)
{
#ifdef TEST1
	printf("chdir:p=%s->%s\n",names[N_PATH],n);
#endif
	if(!getfname(n,cn,&d,3))
	{
		int i,l=(int)strlen(cn);
		char *n2,*n3,*np=names[N_PATH];
		n2=np;

		for(i=0;i<l;i++)
		{
			np[0]='\0';
			if(cn[i]=='\\')
			{
				if(cn[i+1]=='.')
				{
					if(cn[i+2]=='.')
					{
						if((n3=strrchr(n2,'\\'))==NULL)
						{
							i+=2;
							continue;
						} else
						{
							i+=2;
							np=n3;
							continue;
						}
					} else
					{
						if((cn[i+2]=='\\')||(cn[i+2]=='\0'))
						{
							i+=1;
							continue;
						}
					}
				}
			}
			(np++)[0]=cn[i];
		}
		np[0]='\0';
	}
	if(names[N_PATH][strlen(names[N_PATH])-1]!='\\')
		strcat(names[N_PATH],"\\");

#ifdef TEST3
	printf("neuer Pfad:%s\n",names[N_PATH]);
#endif
}

int	asst[16];
char assp[16][MAXLINE];

void assini(void)
{
	int i;
	for(i=0;i<15;i++)
	{
		asst[i]=i;
		assp[i][0]='\0';
	}
}

void cassign(char *n)
{
	char *p,*p2;
	int d1 = 0,d = 0,er=0;

	if((p=strchr(n,':')))
	{
		if(isdigit(p[1]))
			d=p[1]&0x0f;
		else
		if(isalpha(p[1]))
			d=(p[1]&0x0f)-1;
		else
			er++;

		if(!er)
		{
			if(isdigit(n[0]))
				asst[d1=(n[0]&0x0f)]=d;
			else
			if(isalpha(n[0]))
				asst[d1=((n[0]&0x0f)-1)]=d;
			else
				er++;
		}

		if(!er)
		{
			p++;
			if((p2=strchr(p,':')))
				strcpy(assp[d1],p2);
			else
				assp[d1][0]='\0';

#ifdef TEST1
			printf("newassign[%d]=%d,%s\n",d1,d,assp[d1]);
#endif
		}
	} else
		er++;
	
	if(er)	
		critical(C_SYNTAX);
}

int assigned(int d,char *nx)
{
	int d2 = 0;
	if((d>=0)&&(d<=15))
	{
#ifdef TEST1
		printf("assigned[%d]=",d);
#endif
		d2=asst[d];
		if(assp[d][0])
		{
			int i,j,l=(int)strlen(assp[d]);
			char *n;
			
			if((n=strchr(nx,':')))
				n++;
			else
				n=nx;

			j=(int)strlen(n);

			for(i=0;i<=j;i++)
				nx[i]=n[i];
			for(i=j;i>=0;i--)
				nx[i+l]=nx[i];
			for(i=0;i<l;i++)
				nx[i]=assp[d][i];
		}
#ifdef TEST1
		printf("%d,%s\n",d2,nx);
#endif
	}
	return(d2);
}		

