  
#include	"iecf.h"
#include	"iec_hw.h"
#include	"iec_main.h"
#include	"iec_loop.h"
#include	"iec_dsk.h"
#include	"iec_prn.h"


#undef	TEST1
#undef	TEST2
#undef	TEST3
#undef	TEST4

static int listen,talk,secadr,cmdfl;


int serveiec()
{
	static int cmd,er=0;

#ifdef TEST1
	printf("\nserveiec:\n");
#endif

/* printf("read rdd=%02x, ctrl=%02x, rdw=%02x\n",rdd(), rdb(0), rdw(0)); */

	iec_setup();

	cmdfl=0;

	/* Loop to get commands during ATN lo ----------------------------*/

	while(1)
	{

/*printf("gotcha: low=%02x, high=%02x, ctrlout=%02x\n",
					rdb_l(), rdb_h(), rdw(1));*/


	    ndaclo();
	    setrx();
	    atnalo();
	    nrfdhi();

/*printf("      : low=%02x, high=%02x, ctrlout=%02x\n",
					rdb_l(), rdb_h(), rdw(1));*/


	    /* wait for DAV lo */
	    while(davishi()) {
	        if(atnishi()) {
#ifdef TEST4
		    printf("wait dav lo -> ATN hi\n");
#endif
		    goto cmd;
		}
	    }
		
	    nrfdlo();

	    cmd=rdd();

	    ndachi();

	    setcmdfl(cmd);

	    while(davislo());
	}

	/* ---------------------------------------------------------------*/

cmd:

#ifdef TEST2
	printf("listen=%02x, talk=%02x, secadr=%02x\n",listen,talk,secadr);
	printf("low=%02x, high=%02x, ctrlout=%02x\n",rdb_l(), rdb_h(), rdw(1));
#endif

	ledan();	/* LED on */

	if(listen)
	{
		nrfdlo();
		atnahi();
		if(listen==PRN)
		{
			if(prnlistenloop(secadr))
				listen=0;
		} else 
		if(listen==DSK)
		{
			if(dsklistenloop(secadr))
				listen=0;
		}
	} else
	{
		atnahi();
		nrfdhi();

		if(talk==DSK)
		{
			if(dsktalkloop(secadr)) {
				talk=0;
			}
		}
	}
	iec_setup();	/* implicit LED off */

	return(er);
}

#define	LISTEN	0x20
#define	TALK	0x40
#define	SECADR	0x60

void setcmdfl(int cmd)
{
	int adr,icmd;

#ifdef TEST2
	printf("cmd=%02x\n",cmd);
#endif

	adr=cmd&0x1f;
	icmd=cmd&0xe0;

	if(icmd==LISTEN)
	{
		if(adr==0x1f)
			listen=0;
		else
		if((adr==PRN)||(adr==DSK))
		{
			listen=adr;
			talk=0;
			cmdfl=1;
		}
	} else
	if(icmd==TALK)
	{
		if(adr==0x1f)
			talk=0;
		else
		if(adr==PRN||adr==DSK)	
		{
			talk=adr;
			listen=0;
			cmdfl=1;
		}
	} else
	if(((cmd&0x60)==SECADR)&&cmdfl)
	{
		secadr=cmd;
		if((listen==DSK)&&((cmd&0xf0)==0xe0))
			iclose(secadr&0x0f);
	}		
}


int	liecin(int *c)
{
	int er;

#ifdef TEST4
	int foo = 0;
	printf("liecin: %02x\n",rdb_l());
#endif

	er=0;

	nrfdhi();

#ifdef TEST4
	printf("nrfd hi ->%02x\n",rdb_l());
#endif

	while(davishi()) {
#ifdef TEST4
	    if(!foo) printf("wait ndac hi ->%02x\n",rdb_l());
	    foo=1;
#endif
	    if(atnislo()) {
#ifdef TEST4
		printf("wait dav lo -> ATN\n");
#endif
		goto atn;
	    }
	}

	nrfdlo();

	if(!eoiishi())
		er|=E_EOI;
	*c=rdd();

	ndachi();

	while( davislo() ) {
#ifdef TEST4
	    if(!foo) printf("wait dav hi ->%02x\n",rdb_l());
	    foo=1;
#endif
	    if(atnislo()) {
#ifdef TEST4
		printf("wait dav hi -> ATN\n");
#endif
		break;
	    }
	}

	ndaclo();

#ifdef TEST4
	printf("lownib=%02x, rdd->%02x\n",rdb_l(),*c);
#endif

#ifdef TEST3
	printf("liecin: c=%02x (%c), er=%d\n",*c, isprint(*c)?*c:32, er); 
#endif

	return(er);

atn:
	iec_setup();
	return E_ATN;
}


int dsktalkloop(int secadr)
{
        int er,sec;

        er=0;
        sec=secadr&0x0f;

        while (  (!er)   
		&& (!(f[sec].state&S_EOI2))
	        && ((sec==0x0f)||f[sec].state)
        ) {
            settx();            /* enables sending */

#ifdef TEST4
printf("talkl: low=%02x, high=%02x, ctrlout=%02x\n",rdb_l(), rdb_h(), rdw(1));
#endif
	    /* wait nrfd hi */
	    do {
		if(atnislo()) goto atn;
	    } while( nrfdislo() );

	    /* write data & eoi */
            if((f[sec].bf[0]==EOF)||(f[sec].bf[1]==EOF))
            {
                eoilo();
                er|=E_EOI;
            }
            wrd(f[sec].bf[0]);
	    davlo();
#ifdef TEST4
printf("set data %02x\n", f[sec].bf[0]);
#endif

	    /* wait nrfd lo */
	    do {
	        if( atnislo() ) goto atn;

	        if( ndacishi() && nrfdishi() ) {
	    	    eoihi();
		    davhi();
		    return E_NODEV;
	        }
	    } while( nrfdishi() );

#ifdef TEST4
	    printf("     : low=%02x, high=%02x, ctrlout=%02x\n",
						rdb_l(), rdb_h(), rdw(1));
#endif

            fillbuf(sec);

            if(!(er&(~E_EOI)))
            {
		/*printf("foo %c\n", f[sec].bf[0]);*/
                if(er&E_EOI)
                {
                    f[sec].state|=S_EOI2;
                }
                shiftbuf(sec);
            }
	
	    /* wait ndac hi */
	    do {
		if ( atnislo() ) {
		    goto atn;
		}
	    } while( ndacislo() );

	    davhi();
	    eoihi();

	    /* wait ndac lo */
	    do {
		if ( atnislo() ) {
		    goto atn;
		}
	    } while( ndacishi() );

        }
atn:
	iec_setup();

        if((sec==0x0f)&&(f[0x0f].state&S_EOI2))
                critical(C_OK);

        return(er&(E_EOI|E_BRK));
}

