  
#include	"iecf.h"
#include	"iec_hw.h"
#include	"iec_main.h"
#include	"iec_loop.h"
/*
#include	"iec_dsk.h"
#include	"iec_prn.h"
*/
#include	"serial.h"

int talkloop(void);
int listenloop(void);

#define isListening()   ((par_status&0xf000)==0x2000)
#define isTalking()     ((par_status&0xf000)==0x4000)

#undef	TEST1
#undef	TEST2
#undef	TEST3
#undef	TEST4

static int par_status = 0;


int serveiec()
{
	int cmd,er=0;

#ifdef TEST1
	printf("\nserveiec:\n");
#endif

/* printf("read rdd=%02x, ctrl=%02x, rdw=%02x\n",rdd(), rdb(0), rdw(0)); */

	iec_setup();

	par_status=0;

	/* Loop to get commands during ATN lo ----------------------------*/

	while(1)
	{

/*printf("gotcha: low=%02x, high=%02x, ctrlout=%02x\n",
					rdb_l(), rdb_h(), rdw(1));*/


	    ndaclo();
	    setrx();
	    atnalo();
	    nrfdhi();

/*printf("      : low=%02x, high=%02x, ctrlout=%02x\n",
					rdb_l(), rdb_h(), rdw(1));*/


	    /* wait for DAV lo */
	    while(davishi()) {
	        if(atnishi()) {
#ifdef TEST4
		    printf("wait dav lo -> ATN hi\n");
#endif
		    goto cmd;
		}
	    }
		
	    nrfdlo();

	    cmd=rdd();

	    ndachi();

	    par_status = parallelattention(cmd);
	    /* setcmdfl(cmd); */

	    while(davislo());
	}

	/* ---------------------------------------------------------------*/

cmd:

#ifdef TEST2
	printf("listen=%02x, talk=%02x, secadr=%02x\n",listen,talk,secadr);
	printf("low=%02x, high=%02x, ctrlout=%02x\n",rdb_l(), rdb_h(), rdw(1));
#endif

	ledan();	/* LED on */

	if(isListening())
	{
		nrfdlo();
		atnahi();
		listenloop();
	} else
	{
		atnahi();
		nrfdhi();

		if(isTalking()) {
		    talkloop();
		}
	}
	iec_setup();	/* implicit LED off */

	return(er);
}

/***************************************************************************/

int	liecin(int *c)
{
	int er;

#ifdef TEST4
	int foo = 0;
	printf("liecin: %02x\n",rdb_l());
#endif

	er=0;

	nrfdhi();

#ifdef TEST4
	printf("nrfd hi ->%02x\n",rdb_l());
#endif

	while(davishi()) {
#ifdef TEST4
	    if(!foo) printf("wait ndac hi ->%02x\n",rdb_l());
	    foo=1;
#endif
	    if(atnislo()) {
#ifdef TEST4
		printf("wait dav lo -> ATN\n");
#endif
		goto atn;
	    }
	}

	nrfdlo();

	if(!eoiishi())
		er|=E_EOI;
	*c=rdd();

	ndachi();

	while( davislo() ) {
#ifdef TEST4
	    if(!foo) printf("wait dav hi ->%02x\n",rdb_l());
	    foo=1;
#endif
	    if(atnislo()) {
#ifdef TEST4
		printf("wait dav hi -> ATN\n");
#endif
		break;
	    }
	}

	ndaclo();

#ifdef TEST4
	printf("lownib=%02x, rdd->%02x\n",rdb_l(),*c);
#endif

#ifdef TEST3
	printf("liecin: c=%02x (%c), er=%d\n",*c, isprint(*c)?*c:32, er); 
#endif

	return(er);

atn:
	iec_setup();
	return E_ATN;
}

int listenloop() {
	int er, c;
        while(((er=liecin(&c))&E_ATN)!=E_ATN) {
	    par_status = parallelsendbyte(c);
	}
	return 0;
}

/***************************************************************************/

int talkloop()
{
        int er /*,sec*/;
	BYTE c;

        er=0;
        /*sec=secadr&0x0f;*/

        while (1 /*  (!er)   
		&& (!(f[sec].state&S_EOI2))
	        && ((sec==0x0f)||f[sec].state) */
        ) {
            settx();            /* enables sending */

#ifdef TEST4
printf("talkl: low=%02x, high=%02x, ctrlout=%02x\n",rdb_l(), rdb_h(), rdw(1));
#endif
	    /* wait nrfd hi */
	    do {
		if(atnislo()) goto atn;
	    } while( nrfdislo() );

	    /* write data & eoi */
	    par_status = parallelreceivebyte(&c, 1);
            if(par_status & 0x40 /*(f[sec].bf[0]==EOF)||(f[sec].bf[1]==EOF)*/)
            {
                eoilo();
                er|=E_EOI;
            }
            wrd(c /*f[sec].bf[0]*/);
	    davlo();
#ifdef TEST4
printf("set data %02x\n", f[sec].bf[0]);
#endif

	    /* wait nrfd lo */
	    do {
	        if( atnislo() ) goto atn;

	        if( ndacishi() && nrfdishi() ) {
	    	    eoihi();
		    davhi();
		    return E_NODEV;
	        }
	    } while( nrfdishi() );

#ifdef TEST4
	    printf("     : low=%02x, high=%02x, ctrlout=%02x\n",
						rdb_l(), rdb_h(), rdw(1));
#endif

            /*fillbuf(sec);*/

            if(!(er&(~E_EOI)))
            {
		/*printf("foo %c\n", f[sec].bf[0]);*/
/*
                if(er&E_EOI)
                {
                    f[sec].state|=S_EOI2;
                }
*/
                /*shiftbuf(sec);*/
            }
	
	    /* wait ndac hi */
	    do {
		if ( atnislo() ) {
		    goto atn;
		}
	    } while( ndacislo() );

	    davhi();
	    eoihi();
	    par_status = parallelreceivebyte(&c, 0);

	    /* wait ndac lo */
	    if( par_status & 0xff ) {
		break;
	    } else {
	        do {
		    if ( atnislo() ) {
		        goto atn;
		    }
	        } while( ndacishi() );
	    }

        }
atn:
	iec_setup();

/*
        if((sec==0x0f)&&(f[0x0f].state&S_EOI2))
                critical(C_OK);
*/
        return(er&(E_EOI|E_BRK));
}

