 
#include <unistd.h>
#include <stdlib.h>
#include <assert.h>
 
#include	"iecf.h"
#include	"iec_hw.h"
#include	"iec_loop.h"
#include	"iec_main.h"
#include	"serial.h"
#include	"fsdevice.h"
#include	"vdrive.h"

void usage(void) {
	printf("lptiec usage:\n"
		"  lptiec [options]\n"
		"lptiec emulates a Commodore IEEE488 drive with a special interface at the\n"
		"PC printer port\n\n"
		"options: \n"
		"  -d #        set emulated drive ID for Unix directory drive (default %d)\n"
		"  -f #        set emulated drive ID for d64 file (default %d)\n"
		"  -F file     set filename for d64 file\n"
		"\n",
		DSK1,DSK2
	);
}

int pardebug = 0;

int DSK1, DSK2, PRN;
DRIVE  *floppy;

int init_vice(int dev1, int dev2, char *d64file) {

    int i;

    serial_init(NULL);

    fprintf(stderr,"Setting device No %d to Unix dir\n", dev1);
    initialize_1541(dev1, DT_FS, NULL, NULL, NULL);
    fsdevice_set_directory(".", dev1);

    if(d64file) {
      DRIVE f;

      fprintf(stderr,"Setting device No %d to D64 file %s\n",dev2,d64file);
      initialize_1541(dev2, DT_DISK, NULL, NULL, &f);
      attach_floppy_image(&f, d64file, 0);
    }

    return 0;
}

int main(int argc, char *argv[])
{
	int er;
	int c;
	int flag_daemon = 0;
	pid_t pid;
	char *d64file=NULL;

	DSK1=7;			/* disk drive DRV1 as unix filesystem */
	DSK2=8;			/* disk drive as .d64 file */
	PRN=4;			/* printer is on 4 */

	while( (c=getopt(argc, argv, "?d:f:F:")) != EOF) {
	  switch(c) {
	  case 'd':
		DSK1 = atoi(optarg);
		fprintf(stderr,"Unix drive %d\n",DSK1);
		break;
	  case 'f':
		DSK2 = atoi(optarg);
		fprintf(stderr,"D64 drive %d\n",DSK2);
		break;
	  case 'F':
		d64file = optarg;
		fprintf(stderr,"D64 file %s\n",d64file);
		break;
	  case '?':
		usage();
		exit(0);
		break;
	  case EOF:
		break;
	  }
	}
		

	er = iecini(/* 0x278 */);	/* insert the address of your LPT port */

	if(er < 0) return 1;

	init_vice(DSK1, DSK2, d64file);

        while(1)
        {
                while(atnislo()) {
                        serveiec();
                }
                /* spoolout(); */
                usleep(100);
        }

	return 0;
}


