/*******************************************************/
/* rom.h                                               */
/* (c) by Andreas Matthies                             */
/* please report bugs and comments to                  */
/* email: andreas.matthies@arcormail.de                */
/*******************************************************/

#ifndef _rom
#define _rom

#include "loader.h"

typedef enum {bit0,bit1,bytesync,wrongtrigger,halfbit,parity_ok,parity_error} rombitstate_t;


struct rominfo_t {
	unsigned char header[MAXCBMHEADERSIZE];
	unsigned char datachksum;
	unsigned char chksum;
	unsigned char actualbyte;
	long nextdatabyte,nextheaderbyte;
	long lastdatabyte,lastheaderbyte;
	unsigned char nextbit;
	char halfbit; /* for normal tape coding */
	tap_t firsttrigger; /* first trigger of a normal coded bit */
	char bitparity;
};

static void reset_rom();
static void init_rom();
static void analyse_rom(prg_t *p,tap_t t);

extern struct loader_t rom;

#endif
