/*
  File autogenerated by gengetopt version 2.2  
  generated with the following command:
  gengetopt -itapir.ggo 

  The developers of gengetopt consider the fixed text that goes in all
  gengetopt output files to be in the public domain:
  we make no copyright claims on it.
*/


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
/* If we use autoconf.  */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
/* Check for configure's getopt check result.  */
#ifndef HAVE_GETOPT_LONG
#include "getopt.h"
#else
#include <getopt.h>
#endif

#include "cmdline.h"


static void
print_version (void)
{
  printf ("%s %s\n", PACKAGE, VERSION);
}

static void
print_help (void)
{
  print_version ();
  printf ("Usage: %s [OPTIONS]...\n\
   -h         --help            Print help and exit\n\
   -V         --version         Print version and exit\n\
   -oSTRING   --outfile=STRING  Output file name\n\
   -sSTRING   --source=STRING   Name of sound input\n\
   -nINT      --number=INT      Number of sound input\n\
   -i         --invert          Invert input (default=off)\n\
   -tSTRING   --type=STRING     Source computer type\n\
   -cLONG     --clock=LONG      Source clock frequency\n\
   -v         --verbose         Verbose flag (default=off)\n\
   -d         --debug           Debug flag (default=off)\n\
   -fLONG     --rate=LONG       Samplerate\n\
   -m         --mono            Mono mode (default=on)\n\
   -bINT      --bits=INT        Bits per sample\n\
   -SFLOAT    --speed=FLOAT     Speed correction factor\n\
   -l         --level           Show input level (default=off)\n\
   -LSTRING   --loader=STRING   Loader type\n\
", PACKAGE);
}


static char *
gengetopt_strdup (char * s)
{
  char * n, * pn, * ps = s;
  while (*ps) ps++;
  n = (char *) malloc (1 + ps - s);
  if (n != NULL)
    {
      for (ps=s,pn=n; *ps; ps++,pn++)
        *pn = *ps;
      *pn = 0;
    }
  return n;
}


int
cmdline_parser (int argc, char * const *argv, struct gengetopt_args_info *args_info)
{
  int c;	/* Character of the parsed option.  */
  int missing_required_options = 0;	

  args_info->help_given = 0 ;
  args_info->version_given = 0 ;
  args_info->outfile_given = 0 ;
  args_info->source_given = 0 ;
  args_info->number_given = 0 ;
  args_info->invert_given = 0 ;
  args_info->type_given = 0 ;
  args_info->clock_given = 0 ;
  args_info->verbose_given = 0 ;
  args_info->debug_given = 0 ;
  args_info->rate_given = 0 ;
  args_info->mono_given = 0 ;
  args_info->bits_given = 0 ;
  args_info->speed_given = 0 ;
  args_info->level_given = 0 ;
  args_info->loader_given = 0 ;
#define clear_args() { \
  args_info->outfile_arg = NULL; \
  args_info->source_arg = NULL; \
  args_info->invert_flag = 0;\
  args_info->type_arg = NULL; \
  args_info->verbose_flag = 0;\
  args_info->debug_flag = 0;\
  args_info->mono_flag = 1;\
  args_info->level_flag = 0;\
  args_info->loader_arg = NULL; \
}

  clear_args();

  while (1)
    {
      int option_index = 0;
      static struct option long_options[] = {
        { "help",	0, NULL, 'h' },
        { "version",	0, NULL, 'V' },
        { "outfile",	1, NULL, 'o' },
        { "source",	1, NULL, 's' },
        { "number",	1, NULL, 'n' },
        { "invert",	0, NULL, 'i' },
        { "type",	1, NULL, 't' },
        { "clock",	1, NULL, 'c' },
        { "verbose",	0, NULL, 'v' },
        { "debug",	0, NULL, 'd' },
        { "rate",	1, NULL, 'f' },
        { "mono",	0, NULL, 'm' },
        { "bits",	1, NULL, 'b' },
        { "speed",	1, NULL, 'S' },
        { "level",	0, NULL, 'l' },
        { "loader",	1, NULL, 'L' },
        { NULL,	0, NULL, 0 }
      };

      c = getopt_long (argc, argv, "hVo:s:n:it:c:vdf:mb:S:lL:", long_options, &option_index);

      if (c == -1) break;	/* Exit from `while (1)' loop.  */

      switch (c)
        {
        case 'h':	/* Print help and exit.  */
          clear_args ();
          print_help ();
          exit (0);

        case 'V':	/* Print version and exit.  */
          clear_args ();
          print_version ();
          exit (0);

        case 'o':	/* Output file name.  */
          if (args_info->outfile_given)
            {
              fprintf (stderr, "%s: `--outfile' (`-o') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->outfile_given = 1;
          args_info->outfile_arg = gengetopt_strdup (optarg);
          break;

        case 's':	/* Name of sound input.  */
          if (args_info->source_given)
            {
              fprintf (stderr, "%s: `--source' (`-s') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->source_given = 1;
          args_info->source_arg = gengetopt_strdup (optarg);
          break;

        case 'n':	/* Number of sound input.  */
          if (args_info->number_given)
            {
              fprintf (stderr, "%s: `--number' (`-n') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->number_given = 1;
          args_info->number_arg = atoi (optarg);
          break;

        case 'i':	/* Invert input.  */
          args_info->invert_flag = !(args_info->invert_flag);
          break;

        case 't':	/* Source computer type.  */
          if (args_info->type_given)
            {
              fprintf (stderr, "%s: `--type' (`-t') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->type_given = 1;
          args_info->type_arg = gengetopt_strdup (optarg);
          break;

        case 'c':	/* Source clock frequency.  */
          if (args_info->clock_given)
            {
              fprintf (stderr, "%s: `--clock' (`-c') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->clock_given = 1;
          args_info->clock_arg = atol (optarg);
          break;

        case 'v':	/* Verbose flag.  */
          args_info->verbose_flag = !(args_info->verbose_flag);
          break;

        case 'd':	/* Debug flag.  */
          args_info->debug_flag = !(args_info->debug_flag);
          break;

        case 'f':	/* Samplerate.  */
          if (args_info->rate_given)
            {
              fprintf (stderr, "%s: `--rate' (`-f') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->rate_given = 1;
          args_info->rate_arg = atol (optarg);
          break;

        case 'm':	/* Mono mode.  */
          args_info->mono_flag = !(args_info->mono_flag);
          break;

        case 'b':	/* Bits per sample.  */
          if (args_info->bits_given)
            {
              fprintf (stderr, "%s: `--bits' (`-b') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->bits_given = 1;
          args_info->bits_arg = atoi (optarg);
          break;

        case 'S':	/* Speed correction factor.  */
          if (args_info->speed_given)
            {
              fprintf (stderr, "%s: `--speed' (`-S') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->speed_given = 1;
          args_info->speed_arg = (float)strtod (optarg, NULL);
          break;

        case 'l':	/* Show input level.  */
          args_info->level_flag = !(args_info->level_flag);
          break;

        case 'L':	/* Loader type.  */
          if (args_info->loader_given)
            {
              fprintf (stderr, "%s: `--loader' (`-L') option given more than once\n", PACKAGE);
              clear_args ();
              print_help ();
              exit (1);
            }
          args_info->loader_given = 1;
          args_info->loader_arg = gengetopt_strdup (optarg);
          break;

        case 0:	/* Long option with no short option */

        case '?':	/* Invalid option.  */
          /* `getopt_long' already printed an error message.  */
          exit (1);

        default:	/* bug: option not considered.  */
          fprintf (stderr, "%s: option unknown: %c\n", PACKAGE, c);
          abort ();
        } /* switch */
    } /* while */

  if ( missing_required_options )
    exit (1);


  return 0;
}
