#ifdef WIN32
# include <windows.h>
#endif
#include <stdio.h>
#include "tapir.h"
#include "sound.h"

#define FILTER_LENGTH COEFFICIENTS_LENGTH
/* #define FILTER_LENGTH 25 */
#define FIRBUFF_LENGTH 64 /* the smallest 2^n larger than FILTER_LENGTH */

/* ~500 ms average with the highest samplerate */
/* This is used to remove DC offset which can be pretty high
   with crappy walkmans (such as mine). */
#define AVERAGE_BUFFER_LENGTH 25000

/* Only for 48kHz samplerate. Will have to be fixed somehow... */
#include "coefficients.h"
double filter_coeff[] = COEFFICIENTS;

void filter_buffer(short *indata, double *outdata, int length, int invert, uint8 sample_format)
{

    static double firbuff[FIRBUFF_LENGTH] = {0.0};
    static int firptr;
    /*
    static double avg[AVERAGE_BUFFER_LENGTH] = {0.0};
    static uint16 avg_index = AVERAGE_BUFFER_LENGTH;
    static double average = 0;
    */
    int i;

    for (i=0; i<length; i++) {

        double facc=0.0;
        int j;
        int firptr2 = firptr;

/*        firbuff[firptr] = (sample_format == SIXTEEN_BITS) ?
	  indata[i] : ((int16)indata[i] - 0x80) * 0x100; */
        firbuff[firptr] = indata[i];

        for (j=0; j<FILTER_LENGTH; j++) {

            facc += firbuff[firptr2]*filter_coeff[j];
            firptr2++;
            if (firptr2 >= FIRBUFF_LENGTH)
                firptr2 = 0;
        }

	/* The offset removal isn't needed anymore as it's all taken
	   care of in the filter. */
#if 0
	/* Collect a moving average for removing DC offset */
	++avg_index;
	avg_index %= AVERAGE_BUFFER_LENGTH;
	
	/* Remove oldest value from average */
	average -= avg[avg_index]/AVERAGE_BUFFER_LENGTH;
	
	/* Remember value and add to average */
	avg[avg_index] = facc;
	average += facc/AVERAGE_BUFFER_LENGTH;
	
	if(options.debug_flag) {
	    if(avg_index == 0) {
		printf("Avg: %5.1f\n", average);
	    }
	}
	/* Remove the offset */
	facc -= average;
#endif

        if (invert)
            outdata[i]=-facc;
        else
            outdata[i]=facc;

        firptr++;
        if (firptr >= FIRBUFF_LENGTH)
            firptr = 0;
    }
}

void convert_buffer(short *indata, double *outdata, int length, int invert)
{
    int i;
    for (i=0; i<length; i++)
    {
        if (invert)
            outdata[i] = -indata[i];
        else
            outdata[i] = indata[i];
    }
}
