#include "tapir.h"

void write_output_data(double pulselen, uint32 fs)
{
    switch(settings.loader)
    {
    case TAP:
        write_tap_data(pulselen, fs);
        break;
    case TURBO:
        write_turbo_data(pulselen, fs);
        break;
    default:
        break;
    }
}

int open_output_file(char *name)
{
    switch(settings.loader)
    {
    case TAP:
        return open_tap_file(name);
    case TURBO:
     /* Not exactly the most beautiful solution around, but it works...
        return open_turbo_file("default.prg"); */
        return TRUE;
    default:
        break;
    }
    return FALSE;
}

int close_output_file(void)
{
    switch(settings.loader)
    {
    case TAP:
        return close_tap_file();
    case TURBO:
        return close_turbo_file();
    default:
        break;
    }
    return TRUE;
}

